local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'obstacles_master')
local analytics = game.analyticsHelper
sprite:clearcache()


local WorldSets = {

-- World 0
	{
	-- Tutorial Scenes
		96,
		89,
		95,
		98,
		93,
		102,
		97,
		82,
		99,
		86	
	},

-- World 1
	{
		-- Set 1
		{
			-- Easy[v]
			{
				11,
				48,
				49,
				52,
				59,
				94
			},
			
			-- Medium
			{
				110,
				111
			},
			
			-- Hard
			{
				110,
				111
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		}, 
		-- Set 2
		{
			-- Easy[v]
			{
				57,
				27,
				38,
				22,
				17
			},
			
			-- Medium
			{
				115,
				116
			},
			
			-- Hard
			{
				115,
				116
			},
			
			-- Balance
			{
				100,	-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		},
		-- Set 3
		{
			-- Easy[v]
			{
				13,
				25,
				33,
				39,
				41
			},
			
			-- Medium
			{
				120,
				121
			},
			
			-- Hard
			{
				120,
				121
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		}
	},	
-- World 2
	{
		-- Set 1
		{
			-- Easy[v]
			{
				32,
				34,
				36,
				31,
				26
			},
			
			-- Medium
			{
				120,
				121
			},
			
			-- Hard
			{
				120,
				121
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		},
		-- Set 2
		{
			-- Easy[v]
			{
				45,
				24,
				40,
				42,
				30
			},
			
			-- Medium
			{
				120,
				121
			},
			
			-- Hard
			{
				120,
				121
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		},
		-- Set 3
		{
			-- Easy[v]
			{
				27,
				57,
				13,
				49,
				94
			},
			
			-- Medium[v]
			{
				24,
				31,
				32,
				34,
				45
			},
			
			-- Hard
			{
				120,
				121
			},
			
			-- Balance
			{
				30,		-- Easy Scenes
				70,		-- Medium Scenes
				0		-- Hard Scenes
			}
		}
		,
		-- Set 4
		{
			-- Easy[v]
			{
				41,
				48,
				22,
				13,
				25
			},
			
			-- Medium[v]
			{
				30,
				42,
				36,
				26,
				40
			},
			
			-- Hard
			{
				120,
				121
			},
			
			-- Balance
			{
				30,		-- Easy Scenes
				70,		-- Medium Scenes
				0		-- Hard Scenes
			}
		},
		-- Set 5
		{
			-- Easy[v]
			{
				39,
				36,
				57,
				38,
				11
			},
			
			-- Medium[v]
			{
				45,
				33,
				26,
				42,
				31
			},
			
			-- Hard
			{
				120,
				121
			},
			
			-- Balance
			{
				30,	-- Easy Scenes
				70,		-- Medium Scenes
				0		-- Hard Scenes
			}
		}
	},	
-- World 3
	{
		-- Set 1
		{
			-- Easy
			{
				20,
				23,
				35,
				46,
				51
			},
			
			-- Medium
			{
				110,
				111
			},
			
			-- Hard
			{
				110,
				111
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		}, 
		-- Set 2
		{
			-- Easy
			{
				56,
				43,
				44,
				71,
				47
			},
			
			-- Medium
			{
				115,
				116
			},
			
			-- Hard
			{
				115,
				116
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		},
		-- Set 3
		{
			-- Easy
			{30,42,36,26,40},			
			-- Medium
			{24,31,32,34,45},			
			-- Hard
			{43,44,47,71,56},			
			-- Balance
			{
				15,	-- Easy Scenes
				25,	-- Medium Scenes
				60	-- Hard Scenes
			}
		},
		-- Set 4
		{
			-- Easy
			{17,22,27,38,57},			
			-- Medium
			{30,42,36,26,40},			
			-- Hard
			{20,23,35,46,51},			
			-- Balance
			{
				15,	-- Easy Scenes
				25,	-- Medium Scenes
				60	-- Hard Scenes
			}
		},
		-- Set 5
		{
			-- Easy
			{27,22,11,52,48},			
			-- Medium
			{45,33,26,42,31},			
			-- Hard
			{47,23,71,46,56},			
			-- Balance
			{
				15,	-- Easy Scenes
				25,	-- Medium Scenes
				60	-- Hard Scenes
			}
		},
		-- Set 6
		{
			-- Easy
			{48,94,49,32,59},			
			-- Medium
			{39,26,42,25,24},			
			-- Hard
			{35,44,20,51,47},			
			-- Balance
			{
				15,	-- Easy Scenes
				25,	-- Medium Scenes
				60	-- Hard Scenes
			}
		},
		-- Set 7
		{
			-- Easy
			{17,38,22,13,25},			
			-- Medium
			{41,48,40,42,45},			
			-- Hard
			{23,31,47,71,45},			
			-- Balance
			{
				15,	-- Easy Scenes
				25,	-- Medium Scenes
				60	-- Hard Scenes
			}
		},
		-- Set 8
		{
			-- Easy
			{39,33,57,38,11},			
			-- Medium
			{26,31,32,34,36},			
			-- Hard
			{71,42,26,25,32},			
			-- Balance
			{
				15,	-- Easy Scenes
				25,	-- Medium Scenes
				60	-- Hard Scenes
			}
		}
	},	
-- World 4
	{
		-- Set 1
		{
			-- Easy
			{30,42,36,26,40}, -- dummy
			-- Medium
			{53,54,55,61,70},			
			-- Hard
			{43,44,47,71,56}, -- dummy
			-- Balance
			{
				0,	-- Easy Scenes
				100,	-- Medium Scenes
				0	-- Hard Scenes
			}
		},
		-- Set 2
		{
			-- Easy
			{30,42,36,26,40}, -- dummy
			-- Medium
			{37,50,58,65,72},			
			-- Hard
			{43,44,47,71,56}, -- dummy
			-- Balance
			{
				0,	-- Easy Scenes
				100,	-- Medium Scenes
				0	-- Hard Scenes
			}
		},
		-- Set 3
		{
			-- Easy
			{17,22,27,38,57}, 
			-- Medium
			{20,23,35,46,51},			
			-- Hard
			{37,50,58,65,72}, 
			-- Balance
			{
				10,	-- Easy Scenes
				20,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 4
		{
			-- Easy
			{48,49,52,59,94}, 
			-- Medium
			{43,44,47,56,71},			
			-- Hard
			{53,54,55,61,70}, 
			-- Balance
			{
				10,	-- Easy Scenes
				20,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 5
		{
			-- Easy
			{26,31,32,34,36}, 
			-- Medium
			{47,23,71,46,56},			
			-- Hard
			{37,54,58,61,72}, 
			-- Balance
			{
				10,	-- Easy Scenes
				20,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 6
		{
			-- Easy
			{39,33,57,98,11}, 
			-- Medium
			{23,31,47,71,45},			
			-- Hard
			{53,50,55,65,70}, 
			-- Balance
			{
				10,	-- Easy Scenes
				20,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 7
		{
			-- Easy
			{39,26,42,25,24}, 
			-- Medium
			{71,42,33,25,27},			
			-- Hard
			{58,20,65,32,50}, 
			-- Balance
			{
				10,	-- Easy Scenes
				20,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 8
		{
			-- Easy
			{52,94,22,26,56}, 
			-- Medium
			{24,30,40,42,45},			
			-- Hard
			{55,65,20,31,53}, 
			-- Balance
			{
				10,	-- Easy Scenes
				20,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 9
		{
			-- Easy
			{52,94,22,26,56}, -- dummy
			-- Medium
			{24,30,40,42,45}, -- dummy	
			-- Hard
			{53,33,54,55,44}, 
			-- Balance
			{
				0,	-- Easy Scenes
				0,	-- Medium Scenes
				100	-- Hard Scenes
			}
		},
		-- Set 10
		{
			-- Easy
			{52,94,22,26,56}, -- dummy
			-- Medium
			{24,30,40,42,45}, -- dummy	
			-- Hard
			{58,45,22,72,70}, 
			-- Balance
			{
				0,	-- Easy Scenes
				0,	-- Medium Scenes
				100	-- Hard Scenes
			}
		},
		-- Set 11
		{
			-- Easy
			{52,94,22,26,56}, -- dummy
			-- Medium
			{26,31,32,34,36}, 
			-- Hard
			{37,50,58,65,72}, 
			-- Balance
			{
				0,	-- Easy Scenes
				40,	-- Medium Scenes
				60	-- Hard Scenes
			}
		},
		-- Set 12
		{
			-- Easy
			{52,94,22,26,56}, -- dummy
			-- Medium
			{43,44,47,56,71}, 
			-- Hard
			{53,54,55,61,70}, 
			-- Balance
			{
				0,	-- Easy Scenes
				40,	-- Medium Scenes
				60	-- Hard Scenes
			}
		},
		-- Set 13
		{
			-- Easy
			{11,48,49,52,59,94}, 
			-- Medium
			{43,44,47,56,71}, -- dummy
			-- Hard
			{53,33,54,55,44}, 
			-- Balance
			{
				40,	-- Easy Scenes
				0,	-- Medium Scenes
				60	-- Hard Scenes
			}
		},
		-- Set 14
		{
			-- Easy
			{30,42,36,26,40}, 
			-- Medium
			{43,44,47,56,71}, -- dummy
			-- Hard
			{58,45,22,72,70}, 
			-- Balance
			{
				40,	-- Easy Scenes
				0,	-- Medium Scenes
				60	-- Hard Scenes
			}
		}		
	},
	
-- World 5
	{
		-- Set 1
		{
			-- Easy
			{30,42,36,26,40}, -- dummy
			-- Medium
			{43,44,47,56,71}, -- dummy
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				0,	-- Easy Scenes
				0,	-- Medium Scenes
				100	-- Hard Scenes
			}
		},
		-- Set 2
		{
			-- Easy
			{30,42,36,26,40}, -- dummy
			-- Medium
			{53,54,55,61,70}, 
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				0,	-- Easy Scenes
				30,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 3
		{
			-- Easy
			{30,42,36,26,40}, -- dummy
			-- Medium
			{37,50,58,65,72}, 
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				0,	-- Easy Scenes
				30,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 4
		{
			-- Easy
			{30,42,36,26,40}, -- dummy
			-- Medium
			{20,23,35,46,51}, 
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				0,	-- Easy Scenes
				30,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 5
		{
			-- Easy
			{30,42,36,26,40}, -- dummy
			-- Medium
			{43,44,47,56,71}, 
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				0,	-- Easy Scenes
				30,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 6
		{
			-- Easy
			{17,22,27,38,57},
			-- Medium
			{53,54,55,61,70}, 
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				20,	-- Easy Scenes
				40,	-- Medium Scenes
				40	-- Hard Scenes
			}
		},
		-- Set 7
		{
			-- Easy
			{11,48,49,52,59,94},
			-- Medium
			{37,50,58,65,72}, 
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				20,	-- Easy Scenes
				40,	-- Medium Scenes
				40	-- Hard Scenes
			}
		},
		-- Set 8
		{
			-- Easy
			{11,48,49,52,59,94}, -- dummy
			-- Medium
			{53,54,55,61,70}, 
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				0,	-- Easy Scenes
				50,	-- Medium Scenes
				50	-- Hard Scenes
			}
		},
		-- Set 9
		{
			-- Easy
			{11,48,49,52,59,94}, -- dummy
			-- Medium
			{37,50,58,65,72}, 
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				0,	-- Easy Scenes
				50,	-- Medium Scenes
				50	-- Hard Scenes
			}
		},
		-- Set 10
		{
			-- Easy
			{20,23,35,46,51}, 
			-- Medium
			{37,50,58,65,72}, -- dummy
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				20,	-- Easy Scenes
				0,	-- Medium Scenes
				80	-- Hard Scenes
			}
		},
		-- Set 11
		{
			-- Easy
			{20,23,35,46,51}, -- dummy
			-- Medium
			{26,31,32,34,36}, 
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				0,	-- Easy Scenes
				50,	-- Medium Scenes
				50	-- Hard Scenes
			}
		},
		-- Set 12
		{
			-- Easy
			{20,23,35,46,51}, -- dummy
			-- Medium
			{41,48,40,42,45}, 
			-- Hard
			{74,53,75,54,76}, 
			-- Balance
			{
				0,	-- Easy Scenes
				30,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 13
		{
			-- Easy
			{20,23,35,46,51}, -- dummy
			-- Medium
			{47,23,71,46,56}, 
			-- Hard
			{73,37,77,50,61}, 
			-- Balance
			{
				0,	-- Easy Scenes
				30,	-- Medium Scenes
				70	-- Hard Scenes
			}
		},
		-- Set 14
		{
			-- Easy
			{20,23,35,46,51}, 
			-- Medium
			{47,23,71,46,56}, -- dummy
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				20,	-- Easy Scenes
				0,	-- Medium Scenes
				80	-- Hard Scenes
			}
		},
		-- Set 15
		{
			-- Easy
			{48,94,49,32,59}, 
			-- Medium
			{24,31,32,34,45}, 
			-- Hard
			{73,74,75,76,77}, 
			-- Balance
			{
				20,	-- Easy Scenes
				30,	-- Medium Scenes
				50	-- Hard Scenes
			}
		},
		-- Set 16
		{
			-- Easy
			{48,94,49,32,59}, --dummy
			-- Medium
			{24,31,32,34,45}, --dummy
			-- Hard
			{73,43,75,50,77}, 
			-- Balance
			{
				0,	-- Easy Scenes
				0,	-- Medium Scenes
				100	-- Hard Scenes
			}
		},
		-- Set 17
		{
			-- Easy
			{48,94,49,32,59}, --dummy
			-- Medium
			{24,31,32,34,45}, --dummy
			-- Hard
			{47,74,75,41,77}, 
			-- Balance
			{
				0,	-- Easy Scenes
				0,	-- Medium Scenes
				100	-- Hard Scenes
			}
		},
		-- Set 18
		{
			-- Easy
			{48,94,49,32,59}, --dummy
			-- Medium
			{24,31,32,34,45}, --dummy
			-- Hard
			{77,40,75,94,57}, 
			-- Balance
			{
				0,	-- Easy Scenes
				0,	-- Medium Scenes
				100	-- Hard Scenes
			}
		},
		-- Set 19
		{
			-- Easy
			{48,94,49,32,59}, --dummy
			-- Medium
			{24,31,32,34,45}, --dummy
			-- Hard
			{76,38,75,37,55}, 
			-- Balance
			{
				0,	-- Easy Scenes
				0,	-- Medium Scenes
				100	-- Hard Scenes
			}
		},
		-- Set 20
		{
			-- Easy
			{48,94,49,32,59}, --dummy
			-- Medium
			{24,31,32,34,45}, --dummy
			-- Hard
			{75,23,53,76,39}, 
			-- Balance
			{
				0,	-- Easy Scenes
				0,	-- Medium Scenes
				100	-- Hard Scenes
			}
		}

	},
	
-- World 6
	{
		-- Set 1
		{
			-- Easy
			{
				59,
				11,
				48,
				52,
				49
			},
			
			-- Medium
			{
				110,
				111
			},
			
			-- Hard
			{
				110,
				111
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		}, 
		-- Set 2
		{
			-- Easy
			{
				57,
				27,
				38,
				22,
				17
			},
			
			-- Medium
			{
				115,
				116
			},
			
			-- Hard
			{
				115,
				116
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		},
		-- Set 3
		{
			-- Easy
			{
				13,
				39,
				25,
				33,
				41
			},
			
			-- Medium
			{
				120,
				121
			},
			
			-- Hard
			{
				120,
				121
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		},
		-- Set 4
		{
			-- Easy
			{
				32,
				34,
				36,
				31,
				26
			},
			
			-- Medium
			{
				120,
				121
			},
			
			-- Hard
			{
				120,
				121
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		},
		-- Set 5
		{
			-- Easy
			{
				23,
				51,
				46,
				35,
				20
			},
			
			-- Medium
			{
				120,
				121
			},
			
			-- Hard
			{
				120,
				121
			},
			
			-- Balance
			{
				100,		-- Easy Scenes
				0,		-- Medium Scenes
				0		-- Hard Scenes
			}
		}
	}
}

-------------------------------------------------------------------------------------------
local WorldZeroChance = 0
local easyChance = 0
local mediumChance = 0
local hardChance = 0
local selectedSet = 1
--rank_for_scenes = 0

local DIFFICULTY_BALANCE = 4
local EASY = 1
local MEDIUM = 2
local HARD = 3

	print("Running fill_scenes_array. rank_for_scenes - " .. rank_for_scenes)
if(rank_for_scenes <= 0) then
	
	world_zero_number_of_scenes = #WorldSets[1]	
	print("Number of scenes in world ZERO: " .. world_zero_number_of_scenes)
	
	selectedSet = 1
	
	avg_total_level_distance = ((world_zero_number_of_scenes) * 2250 + 2000)
	WorldZeroChance = 100
	easyChance = 0
	mediumChance = 0
	hardChance = 0
	if rank_for_scenes < 0 then 
		print("This should never happen:: rank_for_scenes = " .. rank_for_scenes)
	end
	rank_for_scenes = 0
end


-- Configure scenes difficulty probability
if(rank_for_scenes > 0) then
	self.create_networkrand({min_range = 1, max_range = #WorldSets[rank_for_scenes + 1]})
	
	if debug_set_num > 0 then 		
		selectedSet = debug_set_num
	else
		selectedSet = tmp_x
		print("NETWORK_TIME=" .. NETWORK_TIME .. ", selectedSet = " .. tmp_x)
	end

	easyChance = WorldSets[rank_for_scenes + 1][selectedSet][DIFFICULTY_BALANCE][EASY]
	mediumChance = WorldSets[rank_for_scenes + 1][selectedSet][DIFFICULTY_BALANCE][MEDIUM]
	hardChance = WorldSets[rank_for_scenes + 1][selectedSet][DIFFICULTY_BALANCE][HARD]
end

local activeSet = WorldSets[rank_for_scenes + 1][selectedSet]

print("Easy chance: " .. easyChance .. " Medium chance: " .. mediumChance .. " Hard chance: " .. hardChance .. " active Set: " .. selectedSet)

scenes_stock = {}
local debug_easy_counter = 0
local debug_medium_counter = 0
local debug_hard_counter = 0
local i = 1

-- If world zero - change index to start from 0 since modulo + 1 is used inside formula
if(rank_for_scenes == 0) then
	i = 0
end

local random_retries = 0
local next_scene = 0
local last_scene = 0

-- create more scenes than needed, to verify game will not "run out of scenes"
local number_of_scenes_to_create = (total_game_length / 1000) + 10

while (i <= number_of_scenes_to_create) do
	self.create_networkrand({min_range = 0, max_range = 100})
	--print("NEXT GROUP - NETWORK RAND: " .. tmp_x)
	local rnd = tmp_x
	random_retries = 0
	
	if(rnd <= WorldZeroChance and WorldZeroChance > 0) then
			tmp_x = ((i % (#WorldSets[1])) + 1)
			next_scene = WorldSets[1][tmp_x]
			debug_easy_counter = debug_easy_counter + 1
	elseif(rnd <= easyChance and easyChance > 0) then
		self.create_networkrand({min_range = 1, max_range = #activeSet[EASY]})
		next_scene = activeSet[EASY][tmp_x]
		while (next_scene == last_scene and random_retries <= 10) do
			self.create_networkrand({min_range = 1, max_range = #activeSet[EASY]})
			next_scene = activeSet[EASY][tmp_x]
			random_retries = random_retries + 1
		end
		debug_easy_counter = debug_easy_counter + 1
	elseif(rnd <= (mediumChance + easyChance) and mediumChance > 0) then
		--next_scene = networkRand(1, #MediumGroup)
		self.create_networkrand({min_range = 1, max_range = #activeSet[MEDIUM]})
		next_scene = activeSet[MEDIUM][tmp_x]
		while (next_scene == last_scene and random_retries <= 10) do
			self.create_networkrand({min_range = 1, max_range = #activeSet[MEDIUM]})
			next_scene = activeSet[MEDIUM][tmp_x]
			random_retries = random_retries + 1
		end
		debug_medium_counter = debug_medium_counter + 1
	elseif(rnd <= (hardChance + mediumChance + easyChance) and hardChance > 0) then
		--next_scene = networkRand(1, #HardGroup)
		self.create_networkrand({min_range = 1, max_range = #activeSet[HARD]})
		next_scene = activeSet[HARD][tmp_x]
		while (next_scene == last_scene and random_retries <= 10) do
			self.create_networkrand({min_range = 1, max_range = #activeSet[HARD]})
			next_scene = activeSet[HARD][tmp_x]
			random_retries = random_retries + 1
		end
		debug_hard_counter = debug_hard_counter + 1
	end

	print("next scene - NETWORK RAND: " .. tmp_x .. " scene: " .. next_scene)
	print("Rank for scenes: " .. rank_for_scenes)
	last_scene = next_scene
	--local scene = {scene_number = next_scene}
	table.insert(scenes_stock, next_scene)
	--scenes_stock{next_scene}
	i = i + 1
end

print("Scenes mix: easy: " .. debug_easy_counter .. " medium: " .. debug_medium_counter .. " hard: " .. debug_hard_counter)
