local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'social_master')
local analytics = game.analyticsHelper
sprite:clearcache()


print("CFriend class definition")

-------------------------------------------------
-- friend class definition
-------------------------------------------------
CFriend = {}
CFriend.__index = CFriend
---------------------------------------------
--pseudo c'tor - redirect to the new() method
setmetatable(CFriend, {
	__call = function (cls, ...)
		return cls.new(...)
	end,
})
----------------------------------------
--actual c'tor
----------------------------------------
-- rank is used as index in friends list for getting the image
function CFriend.New(id, rank, name, score, online_status)
	local this = setmetatable({}, CFriend)
	this.id 	= tonumber(id or -1)
	this.rank 	= tonumber(rank or -1)
	this.name 		= name or "A Friend"	
	this.score 		= tonumber(score or -1)	
	this.online_status = online_status
	return this
end
----------------------------------------
function  CFriend.PrintMe(this, prefix)
	local txt = "friend: id=" .. this.id .. 
				", rank=" .. this.rank .. 
				" , name = " .. this.name .. 
				"score = " .. this.score .. 
				" online = " .. this.online_status
	if(prefix) then	txt = prefix .. txt end
	print(txt)
end
