local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'start_button_iris')
local analytics = game.analyticsHelper
sprite:clearcache()


-- Targetable heroes contain all bot's IDs and mine
local targetableHeroes = {}
for _, heroSprite in ipairs(spriteList(hero)) do
    if (heroSprite.is_shadow == 1) or (heroSprite.my_id == multi_player_id_me) then
        targetableHeroes[heroSprite.my_id] = heroSprite
    end
end

print("YAN PWR:: pwr up events binded")
------------------------------------------------------------------------------
game.networkingEvents.bind(EVENT_MISSLE_POWERUP, function(args)
    local targetId = tonumber(args.id)

    if apply_pwrup_on_all == 1 then 
         for heroId,heroSprite in pairs(targetableHeroes) do
            if heroId ~= targetId and heroSprite ~= nil then 
                print( "heroSprite[".. heroId .."].create_following_missle() called" )
                heroSprite.create_following_missle { target_id = heroId, owner_id = targetId }        
            end
        end
    elseif targetableHeroes[targetId] ~= nil then
        targetableHeroes[targetId].create_following_missle {
            target_id = targetId, owner_id = 0
        }
    end
end)
------------------------------------------------------------------------------
function g_handleSwitchKeysLocally(args)    
	local targetId = tonumber(args.id)
    local applier_id = tonumber(args.applier_id)
    -- in case of apply_pwrup_on_all use targetId as exception
    if apply_pwrup_on_all == 1 then
        for heroId,heroSprite in pairs(targetableHeroes) do
            if heroId ~= applier_id and heroSprite ~= nil then 
                print( "heroSprite[".. heroId .."].apply_switch_controls() called, applier_id = " .. applier_id .. ", targetId = " .. targetId )
                heroSprite.apply_switch_controls {
                                                    on = 1,
                                                    target_id = heroId,
                                                    applier_id = applier_id
                                                 }        
            end
        end
    elseif targetableHeroes[targetId] ~= nil then
        targetableHeroes[targetId].apply_switch_controls {
            on = 1,
            target_id = targetId,
            applier_id = applier_id
        }
    end
end
game.networkingEvents.bind(EVENT_SWITCH_KEYS_POWERUP, g_handleSwitchKeysLocally)
------------------------------------------------------------------------------

