local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'social_master')
local analytics = game.analyticsHelper
sprite:clearcache()


Inbox = {}
Inbox.platform = require 'platform'
Inbox.filename = "inbox_requests.txt"
Inbox.filepath = Inbox.platform.getSandboxStoragePath() .. "/" .. Inbox.filename
Inbox.file = nil
Inbox.requests = {}
Inbox.loadedFriends = {}
-----------------------------------------------------------------------

-----------------------------------------------------------------------
--arg "w"/"a"/"r"
function Inbox.OpenFile(arg)	
	Inbox.file = io.open(Inbox.filepath, arg)
	return Inbox.file
end
-----------------------------------------------------------------------
function Inbox.CloseFile()
	if(Inbox.file ~= nil) then 
		Inbox.file:close() 
		Inbox.file = nil 
	end
end
-----------------------------------------------------------------------
function Inbox.SaveUncheckedRequestsToFile()
	Inbox.OpenFile("w")
	if(Inbox.file) then
		for i=1, #Inbox.requests do
			if (Inbox.requests[i].checked == 0) then
				CRequest.SaveToFile(Inbox.requests[i], Inbox.file)
			end
		end
		Inbox.CloseFile()
	end
end
-----------------------------------------------------------------------
function Inbox.SetNameAndRankToRequest(req)
	for i=1, #Inbox.loadedFriends do
		if (Inbox.loadedFriends[i].id == req.id) then 
			req.rank = Inbox.loadedFriends[i].rank
			req.name = Inbox.loadedFriends[i].name
			return true
		end
	end
	return false
end
-----------------------------------------------------------------------
function Inbox.ReadRequestsFromFile()
	local arr = {}
	Inbox.OpenFile("r")
	if(Inbox.file) then
		local r = 1
		while r do
			r = CRequest.ReadFromFile(Inbox.file)
			table.insert(arr, r)
		end

		--for i=1, #arr do
		--	CRequest.PrintMe(arr[i],"INB:: req => ")
		--end
		--print("INB:: ReadRequestsFromFile() => arr.Length = " .. #arr)
		return arr
	else
		print("INB:: ReadRequestsFromFile() => failed to open file")
		return nil
	end
end
-----------------------------------------------------------
function  Inbox.FindLoadedFriendById(id)
	for i=1, #Inbox.loadedFriends do
		if(Inbox.loadedFriends[i].id == id) then
			return Inbox.loadedFriends[i]
		end
	end
	return nil
end



