local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'social_master')
local analytics = game.analyticsHelper
sprite:clearcache()


-------------------------------------------------
-- request class definition
-------------------------------------------------
CRequest = {}
CRequest.__index = CRequest
---------------------------------------------
--pseudo c'tor - redirect to the new() method
setmetatable(CRequest, {
	__call = function (cls, ...)
		return cls.new(...)
	end,
})
----------------------------------------
--actual c'tor
----------------------------------------
function CRequest.New(friendId, requestId, arg1, arg2, arg3, quantity)
	local this = setmetatable({}, CRequest)
	this.friendId 	= tonumber(friendId or -1)
	this.requestId 	= tonumber(requestId or -1)
	this.arg1 		= tonumber(arg1 or 0)
	this.arg2 		= tonumber(arg2 or 0)
	this.arg3 		= tonumber(arg3 or 0)
	this.quantity 	= tonumber(quantity or 0)
	this.checked	= 0
	this.rank		= -1
	this.name		= "A Friend"
	return this
end
----------------------------------------
function  CRequest.PrintMe(this, prefix)
	local txt = "request: from=" .. this.friendId .. ", type=" .. this.requestId .. 
			", {" .. this.arg1 .. ", " .. this.arg2 .. ", " .. this.arg3 .. ", " .. this.quantity .. " }"
	if(prefix) then	txt = prefix .. txt end
	print(txt)
end
----------------------------------------
function CRequest.SaveToFile(this, file)
	if(file ~= nil) then
		file:write(this.friendId .. "\n")
		file:write(this.requestId .. "\n")
		file:write(this.arg1 .. "\n")
		file:write(this.arg2 .. "\n")
		file:write(this.arg3 .. "\n")
		file:write(this.quantity .. "\n")
	end
end
----------------------------------------
function CRequest.ReadFromFile(file)
	if(file) then
		local  line1 = file:read("*line")
		if(line1) then
			local req = CRequest.New(line1,
									file:read("*line"),
									file:read("*line"),
									file:read("*line"),
									file:read("*line"),
									file:read("*line"))	
			--CRequest.PrintMe(req, "INB:: read from file = ")	
			return req
		else
			-- eof
			return nil	
		end
	else
		print("INB:: ERROR = CRequest.ReadFromFile(file) , file = nil")
		return nil
	end
end
--=========================================================================================================
