local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'preplay_master')
local analytics = game.analyticsHelper
sprite:clearcache()


PlayersNamesStorage = {}

PlayersNamesStorage.platform 	= require 'platform'
PlayersNamesStorage.filename 	= "players_names_storage.txt"
PlayersNamesStorage.filepath 	= PlayersNamesStorage.platform.getSandboxStoragePath() .. "/" .. PlayersNamesStorage.filename
PlayersNamesStorage.file 		= nil
PlayersNamesStorage.names       = {}



-- 1. open file
-- 2. close file
-- 3. read from file
-- 4. unit test
-----------------------------------------------------------------------
function PlayersNamesStorage.Reset()	
	PlayersNamesStorage.names       = {}
	PlayersNamesStorage.file 		= nil
end
-----------------------------------------------------------------------
--arg "w"/"a"/"r"
function PlayersNamesStorage.OpenFile(arg)	
	PlayersNamesStorage.file = io.open(PlayersNamesStorage.filepath, arg)
	return PlayersNamesStorage.file
end
-----------------------------------------------------------------------
function PlayersNamesStorage.CloseFile()
	if(PlayersNamesStorage.file ~= nil) then 
		PlayersNamesStorage.file:close() 
		PlayersNamesStorage.file = nil 
	end
end
-----------------------------------------------------------------------
function PlayersNamesStorage.SaveName(playerId, name)
	PlayersNamesStorage.names[playerId]= name
end
-----------------------------------------------------------------------
function PlayersNamesStorage.SaveNamesToFile()
	local file = PlayersNamesStorage.OpenFile("w")
	if (file ~= nil) then

		for k,v in pairs(PlayersNamesStorage.names) do
			file:write(k .. "\n")
			file:write(v .. "\n")
		end
		PlayersNamesStorage.CloseFile()
	else
		print("NAMES:: can't open file to write!")
	end
end
-----------------------------------------------------------------------
function PlayersNamesStorage.ReadNamesFromFile()
	local file = PlayersNamesStorage.OpenFile("r")
	if(file) then	
		local namesFromFile = {}	
		local ri = 1		
		local rn
		for i=1, 4 do
			ri = file:read("*line")
			rn = file:read("*line")
			if (ri ~= nil and rn ~= nil) then 
				print("------ namesFromFile[" .. ri .. "] = " .. rn)
				namesFromFile[ri] = rn
			else
				print("This should never happen: failed to read name of " .. i .. " player")
			end
		end
		PlayersNamesStorage.CloseFile()
		return namesFromFile
	else
		print("NAMES:: ERROR = can't read from file = nil")
		return nil
	end
end

