local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'game_master')
local analytics = game.analyticsHelper
sprite:clearcache()


NamingMaster = {}
-- file i/o ------------------------------
NamingMaster.platform = require 'platform'
NamingMaster.filename = "naming_master.txt"
NamingMaster.filepath = NamingMaster.platform.getSandboxStoragePath() .. "/" .. NamingMaster.filename
NamingMaster.file = nil
-- data ----------------------------
NamingMaster.name = "Anonymous"


-----------------------------------------------------------------------
--arg "w"/"a"/"r"
function NamingMaster.OpenFile(arg)	
	NamingMaster.file = io.open(NamingMaster.filepath, arg)
	return NamingMaster.file
end
-----------------------------------------------------------------------
function NamingMaster.CloseFile()
	if(NamingMaster.file ~= nil) then 
		NamingMaster.file:close() 
		NamingMaster.file = nil 
	end
end
-----------------------------------------------------------------------
function  NamingMaster.SaveToFile()
	if NamingMaster.name ~= nil then
		local file = NamingMaster.OpenFile("w")
		if file ~= nil then 
			file:write(NamingMaster.name .. "\n")
			NamingMaster.CloseFile()
		end
	end
end
-----------------------------------------------------------------------
function  NamingMaster.ReadFromFile()
	local file = NamingMaster.OpenFile("r")
	local randomNameGenerated = false
	if file ~= nil then 
		NamingMaster.name = file:read("*line")
		if NamingMaster.name ~= nil then
			print("NamingMaster.ReadFromFile:: name = " .. NamingMaster.name)
		else
			print("NamingMaster.ReadFromFile:: name = nil")
			NamingMaster.name = NamingMaster.GetRandomName()
			randomNameGenerated = true
			print("NamingMaster:: random name = " .. NamingMaster.name)
		end
		NamingMaster.CloseFile()
	else
		NamingMaster.name = NamingMaster.GetRandomName()
		randomNameGenerated = true
		print("NamingMaster:: random name = " .. NamingMaster.name)
	end
	if randomNameGenerated == true then 
		NamingMaster.SaveToFile()
	end
end
-----------------------------------------------------------------------
function NamingMaster.GetRandomName()
	local name = ""
	local onlyUserNames = true
	if QA_DISABLE_DEBUG_STUFF == 0 then name = "_" end
	if math.random(100) < 80 and onlyUserNames == false then 
		name = name .. g_RandomNames[math.random(#g_RandomNames)]
	else
		name = name .. "User_" .. math.random(9) .. math.random(9) .. math.random(9) .. math.random(9)
	end	
	return name
end


 NamingMaster.ReadFromFile()
