local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'pet_house')
local analytics = game.analyticsHelper
sprite:clearcache()


local pl
pl = require 'platform'


PetMaster = {}
PetMaster.platform = pl
PetMaster.filename = "pets_info.txt"

PetMaster.filepath = PetMaster.platform.getSandboxStoragePath() .. "/" .. PetMaster.filename

if(pet_total_available <= 0) then
	print("removed pet master storage file if exist but no pet available for player")
	os.remove(PetMaster.filepath)
end

PetMaster.file = nil
PetMaster.slots = {}
--print(PetMaster.filename)

-----------------------------------------------------------------------
function PetMaster.Reset()	
	PetMaster.slots = {}
end
-----------------------------------------------------------------------
--arg "w"/"a"/"r"
function PetMaster.OpenFile(arg)	
	PetMaster.file = io.open(PetMaster.filepath, arg)
	return PetMaster.file
end
-----------------------------------------------------------------------
function PetMaster.CloseFile()
	if(PetMaster.file ~= nil) then PetMaster.file:close() end
end
-----------------------------------------------------------------------

function PetMaster.AddSlot(slot_id, petType, name, description, month, day, hours, minutes, seconds, energy_recharge_time, energy_lives_cap, energy_current_lives, is_egg)
	print("Add slot")
	local s = {}
	s.slot_id = slot_id
	s.petType = petType
	s.name = name
	s.description = description
	s.month = month
	s.day = day
	s.minutes = minutes
	s.seconds = seconds
	s.energy_recharge_time = energy_recharge_time
	s.energy_lives_cap = energy_lives_cap
	s.energy_current_lives = energy_current_lives
	s.is_egg = is_egg
	table.insert(PetMaster.slots, s)
end
-----------------------------------------------------------------------
function PetMaster.SavePetToFile(slot_id, petType, name, description, month, day, hours, minutes, seconds, energy_recharge_time, energy_lives_cap, energy_current_lives, is_egg)
	--print("Save pet to file with slot id: " .. slot_id)
	PetMaster.file:write(slot_id .. "\n")
	PetMaster.file:write(petType .. "\n")
	PetMaster.file:write(name .. "\n")
	PetMaster.file:write(description .. "\n")
	PetMaster.file:write(month .. "\n")
	PetMaster.file:write(day .. "\n")
	PetMaster.file:write(hours .. "\n")
	PetMaster.file:write(minutes .. "\n")
	PetMaster.file:write(seconds .. "\n")
	PetMaster.file:write(energy_recharge_time .. "\n")
	PetMaster.file:write(energy_lives_cap .. "\n")
	PetMaster.file:write(energy_current_lives .. "\n")
	PetMaster.file:write(is_egg .. "\n")
	PetMaster.file:write("----------------------------------------------------" .. "\n")
	print("End -Saved pet to file - is egg: " .. is_egg)
end
-----------------------------------------------------------------------
function PetMaster.ReadPetFromFile()
	local s = {}
	s.slot_id = PetMaster.file:read("*line")
	if(s.slot_id ~= nil) then
		--print("read slot id: " .. s.slot_id)
		s.slot_id = tonumber(s.slot_id)
		s.petType = tonumber(PetMaster.file:read("*line"))
		s.name = PetMaster.file:read("*line")
		s.description = PetMaster.file:read("*line")
		s.month = tonumber(PetMaster.file:read("*line"))
		s.day = tonumber(PetMaster.file:read("*line"))
		s.hours = tonumber(PetMaster.file:read("*line"))
		s.minutes = tonumber(PetMaster.file:read("*line"))
		s.seconds = tonumber(PetMaster.file:read("*line"))
		s.energy_recharge_time = tonumber(PetMaster.file:read("*line"))
		s.energy_lives_cap = tonumber(PetMaster.file:read("*line"))
		s.energy_current_lives = tonumber(PetMaster.file:read("*line"))
		s.is_egg = tonumber(PetMaster.file:read("*line"))
		PetMaster.file:read("*line")
		print("Read pet from file - is egg.. " .. s.is_egg)
		return s
	else
		--print("Read end on NULL")
		return nil
	end
end

-----------------------------------------------------------------------
