local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'pets_storage_master')
local egg_type = game.gm.getLocalIndicator(0, "egg_type")
local analytics = game.analyticsHelper
sprite:clearcache()


local pwr = {}

pwr.shield		= PWR_POWER_SHIELD
pwr.flight		= PWR_FLY
pwr.mine		= PWR_MINE
pwr.love		= PWR_LOVE_ARROW
pwr.ghost		= PWR_GHOST
pwr.dash		= PWR_RUSH
pwr.ebomb		= PWR_SWITCH_CONTROLS
pwr.missile		= PWR_MISSLE
-----------------------------------------
-- powerups durrations
controls_switch_time_period = 3000
flying_time_period 			= 4000
power_shield_time_period 	= 3000
rush_powerup_time_period 	= 3000
ghost_time_period 			= 5000

-- skills time bonus
king_skill_powerup_time_bonus = 2000
-----------------------------------------
local commonCombinations = {
	{pwr.shield, pwr.flight, pwr.mine},
	{pwr.shield, pwr.flight, pwr.love},
	--{pwr.shield, pwr.flight, pwr.ghost},
	{pwr.shield, pwr.mine  , pwr.love}, 
	{pwr.shield, pwr.mine  , pwr.ghost},
	{pwr.shield, pwr.love  , pwr.ghost}
}
-----------------------------------------
local uncommonCombinations = {
	{pwr.flight, pwr.mine, pwr.love},
	--{pwr.flight, pwr.mine, pwr.ghost},
	{pwr.flight, pwr.love, pwr.ghost},
	{pwr.mine, 	 pwr.love, pwr.ghost},
	{pwr.mine, 	 pwr.love, pwr.dash},
	{pwr.mine, 	 pwr.love, pwr.ebomb},
	{pwr.mine, 	 pwr.love, pwr.missile},
	{pwr.mine, 	 pwr.ghost, pwr.dash},
	{pwr.mine, 	 pwr.ghost, pwr.ebomb},
	{pwr.mine, 	 pwr.ghost, pwr.missile},
	{pwr.love, 	 pwr.ghost, pwr.dash},
	{pwr.love, 	 pwr.ghost, pwr.ebomb},
	{pwr.love, 	 pwr.ghost, pwr.missile}
}
----------------------------------------
local rareCombinations = {
	{pwr.mine, pwr.love, pwr.dash},
	{pwr.mine, pwr.love, pwr.ebomb},
	{pwr.mine, pwr.love, pwr.missile},
	{pwr.mine, pwr.ghost, pwr.dash},
	{pwr.mine, pwr.ghost, pwr.ebomb},
	{pwr.mine, pwr.ghost, pwr.missile},
	{pwr.love, pwr.ghost, pwr.dash},
	{pwr.love, pwr.ghost, pwr.ebomb},
	{pwr.love, pwr.ghost, pwr.missile},
	{pwr.mine, pwr.dash, pwr.ebomb},
	{pwr.mine, pwr.dash, pwr.missile},
	{pwr.mine, pwr.ebomb, pwr.missile},
	{pwr.love, pwr.dash, pwr.ebomb},
	{pwr.love, pwr.dash, pwr.missile},
	{pwr.love, pwr.ebomb, pwr.missile},
	{pwr.ghost, pwr.dash, pwr.ebomb},
	{pwr.ghost, pwr.dash, pwr.missile},
	{pwr.ghost, pwr.ebomb, pwr.missile},
	{pwr.dash, pwr.ebomb, pwr.missile}
}
---------------------------------------
local rarityParams = {
						{60,30,10},	-- normal egg
						{20,60,20},	-- gold egg	
						{10,40,50}	-- mystical egg
					}	
---------------------------------------
local petSkins = {
					{PET_ROBOT, PET_CHICK, PET_PURPLE_DRAGON, PET_ROBOT, PET_CHICK, PET_PURPLE_DRAGON, PET_ROBOT, PET_CHICK, PET_PURPLE_DRAGON, PET_ASTROCAT, PET_ALIEN, PET_ANGEL},		-- normal egg
					{PET_ROBOT, PET_CHICK, PET_PURPLE_DRAGON, PET_ASTROCAT, PET_ALIEN, PET_ANGEL, PET_ASTROCAT, PET_ALIEN, PET_ANGEL, PET_ASTROCAT, PET_ALIEN, PET_ANGEL, PET_ASTROCAT, PET_ALIEN, PET_ANGEL, PET_GOLD_DRAGON, PET_DEMON, PET_DEATH_ANGEL},			-- gold egg
					{PET_ALIEN, PET_ANGEL, PET_ASTROCAT, PET_GOLD_DRAGON, PET_DEMON, PET_DEATH_ANGEL, PET_GOLD_DRAGON, PET_DEMON, PET_DEATH_ANGEL, PET_GOLD_DRAGON, PET_DEMON, PET_DEATH_ANGEL}	-- mystical egg
}
---------------------------------------
local combinations = {commonCombinations, uncommonCombinations, rareCombinations}
---------------------------------------

math.randomseed( tonumber(tostring(os.time()):reverse():sub(1,6)) )

-- define rarity according to the egg_type{1,2,3}
-- define cooldown time according to rarity
local rarity = 1
local cooldown = 1
local r = math.random(100)
local R1 = rarityParams[egg_type][1]
local R2 = rarityParams[egg_type][2] + R1
if r<R1 then 
	rarity = 1
	cooldown = 15000
elseif r < R2 then 
	rarity = 2
	cooldown = 12000
else 
	rarity = 3
	cooldown = 10000
end

-- define power-ups combinations as function of rarity
local choosenCombinationGroup = combinations[rarity]
local combNum = math.random(#choosenCombinationGroup)
local comb = choosenCombinationGroup[combNum]

-- define skin according to the egg type
local existedSkins = PetsDataStorage:GetSkinTypes()
local skin
for i=1, 3 do
	skin = petSkins[egg_type][math.random(#petSkins[egg_type])]
	
	local isSkinAlreadyExist = false
	for i = 1, #existedSkins do
		if existedSkins[i] == skin then
			isSkinAlreadyExist = true
			break
		end
	end
	if isSkinAlreadyExist == false then 
		break
	end
end



-- set lottery results in studio global vars
pet_tmp_skin 		= skin
pet_tmp_pwr1 		= comb[1]
pet_tmp_pwr2 		= comb[2]
pet_tmp_pwr3 		= comb[3]
pet_tmp_rarity 		= rarity
pet_tmp_cooldown 	= cooldown



print("From SCRIPT -Pet Attributes- Skin:"..pet_tmp_skin.." Pet PWR1:"..pet_tmp_pwr1.." Pet PWR2:"..pet_tmp_pwr2.." Pet PWR3:"..pet_tmp_pwr3.." Pet rarity : "..pet_tmp_rarity.." Pet Cooldown: "..pet_tmp_cooldown)

