local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'preplay_master')
local analytics = game.analyticsHelper
sprite:clearcache()


local gm = require 'engine.manager'
local resourceManagerLoaded, resourceManager = pcall(require, 'engine.resourceManager')
if resourceManagerLoaded then
-----------------------------------------------------------------------------------
    -- world 1
    local world1Sprites = 
    {
    "down_button_hb",
    "rank_master",
    "bot_master",
    "game_master",
    "up_button_hb",
    "control_button",
    "debug_game_play_text",
    "debug_record_dump",
    "limbo_arrow_button",
    "progression_bar",
    "avatar_outline",
    "pwrup_dbg",
    "pwrup_cooldown_screen",
    "pwrup_symbol",
    "local_hero",
    "are_you_sure_dlg",
    "blue_x_button",
    "chicken_avatar_body",
    "pink_v_button",
    "chicken_avatar",
    "chicken_avatar_head",
    "pause_button",
    "pwrup_button",
    "rank_dbg",
    "pwrup_effect",
    "analytics_master",
    "start_button_iris",
    "hero",
    "camera",
    "chicken_skin",
    "gboost_2d_effect",
    "local_hero_indicator",
    "crest",
    "bands",
    "obstacles_master",
    "bg_factory",
    "bg_tile_2",
    "bg_tile_1",
    "bg_tile_3",
    "ground",
    "ground_grass",
    "rock_1",
    "flower",
    "rock_2",
    "cloud_2",
    "cloud_4",
    "cloud_5",
    "cloud_1",
    "cloud_3",
    "cloud_7",
    "hill_z1",
    "hill_z3",
    "hill_silhouette_3",
    "hill_silhouette_2",
    "dino_cliff",
    "bush_1",
    "leaf_2",
    "bush_2",
    "bush_3",
    "finish_line",
    "sound_manager",
    "wallet",
    "map_master",
    "end_scene_trgr",
    "game_snd_master",
    "touch_shield",
    "block"
    }

    local tutorialSprites = 
    {
    "tutorial_hand",
    "tutorial_slide_label",
    "tutorial_jump_label",
    "gameplay_tutorial_master",
    "tutorial_tap_label",
    "tutorial_controls_projector",
    "tutorial_controls_bg",
    "tutorial_control_text",
    "tutorial_controls_arrow"
    }
    ----------------------------------------------
    -- world2
    local world2Sprites = 
    {
    "magic_tree_2",
    "ground",
    "down_button_hb",
    "rank_master",
    "bot_master",
    "game_master",
    "up_button_hb",
    "control_button",
    "debug_game_play_text",
    "debug_record_dump",
    "limbo_arrow_button",
    "progression_bar",
    "avatar_outline",
    "pwrup_dbg",
    "pwrup_cooldown_screen",
    "pwrup_symbol",
    "local_hero",
    "gameplay_tutorial_master",
    "are_you_sure_dlg",
    "blue_x_button",
    "chicken_avatar_body",
    "pink_v_button",
    "chicken_avatar",
    "chicken_avatar_head",
    "pause_button",
    "pwrup_button",
    "rank_dbg",
    "pwrup_effect",
    "analytics_master",
    "start_button_iris",
    "hero",
    "camera",
    "chicken_skin",
    "gboost_2d_effect",
    "local_hero_indicator",
    "crest",
    "bands",
    "obstacles_master",
    "bg_factory",
    "magic_bg_tile_2",
    "magic_bg_tile_1",
    "magic_bg_tile_3",
    "ground_grass",
    "flower",
    "rock_4",
    "cloud_2",
    "cloud_1",
    "cloud_3",
    "cloud_4",
    "cloud_6",
    "cloud_5",
    "hill_z3",
    "hill_z1",
    "hill_z2",
    "magic_silhouette_2",
    "magic_silhouette_1",
    "magic_cliff",
    "magic_tree_1",    
    "finish_line",
    "magic_witch_silhouette",
    "sound_manager",
    "wallet",
    "map_master",
    "end_scene_trgr",
    "game_snd_master",
    "touch_shield",
    "start_go_txt",
    "side_indicator",
    "acorns_bag",
    "gold_acorns_bag",
    "rainbow_juice",
    "mud_gnd_placeholder",
    "ground_placeholder",
    "block_hb",
    "block",
    "mud_gnd_back",
    "mud_gnd_front",
    "gnd_hb",
    "collectible_bubble"
    }
    ---------------------------------
    --world3
    local world3Sprites = 
    {
    "down_button_hb",
    "rank_master",
    "bot_master",
    "game_master",
    "up_button_hb",
    "control_button",
    "debug_game_play_text",
    "debug_record_dump",
    "limbo_arrow_button",
    "progression_bar",
    "avatar_outline",
    "pwrup_dbg",
    "pwrup_cooldown_screen",
    "pwrup_symbol",
    "local_hero",
    "are_you_sure_dlg",
    "blue_x_button",
    "chicken_avatar_body",
    "pink_v_button",
    "chicken_avatar",
    "chicken_avatar_head",
    "pause_button",
    "pwrup_button",
    "rank_dbg",
    "pwrup_effect",
    "analytics_master",
    "start_button_iris",
    "hero",
    "camera",
    "chicken_skin",
    "gboost_2d_effect",
    "local_hero_indicator",
    "crest",
    "bands",
    "obstacles_master",
    "bg_factory",
    "appoc_bg_tile_2",
    "appoc_bg_tile_1",
    "appoc_bg_tile_3",
    "appoc_ground",
    "ground_grass",
    "rock_3",
    "rock_4",
    "rock_1",
    "rock_2",
    "appoc_cloud",
    "appoc_hill_z2",
    "appoc_hill_z1",
    "appoc_destroyed_silhouette",
    "appoc_silhouette_1",
    "appoc_cliff",
    "bush_2",
    "bush_3",
    "bush_1",
    "block",
    "appoc_tree_2",
    "finish_line",
    "sound_manager",
    "wallet",
    "map_master",
    "end_scene_trgr",
    "game_snd_master",
    "touch_shield"
    }
    ----------------------------------
    -- world4
    local world4Sprites = 
    {
    "down_button_hb",
    "rank_master",
    "bot_master",
    "game_master",
    "up_button_hb",
    "control_button",
    "debug_game_play_text",
    "debug_record_dump",
    "limbo_arrow_button",
    "progression_bar",
    "avatar_outline",
    "pwrup_dbg",
    "pwrup_cooldown_screen",
    "pwrup_symbol",
    "local_hero",
    "are_you_sure_dlg",
    "blue_x_button",
    "chicken_avatar_body",
    "pink_v_button",
    "chicken_avatar",
    "chicken_avatar_head",
    "pause_button",
    "pwrup_button",
    "rank_dbg",
    "pwrup_effect",
    "analytics_master",
    "start_button_iris",
    "hero",
    "camera",
    "chicken_skin",
    "gboost_2d_effect",
    "local_hero_indicator",
    "crest",
    "bands",
    "obstacles_master",
    "bg_factory",
    "dog_bg_tile_2",
    "dog_bg_tile",
    "dog_bg_tile_3",
    "ground",
    "ground_grass",
    "cave_bone",
    "cloud_1",
    "dog_cloud",
    "cloud_5",
    "cloud_3",
    "cloud_6",
    "hill_z3",
    "hill_z2",
    "cave_mountains_silhouette_1",
    "cave_dolmen_2",
    "dog_cliff",
    "cave_tree_1",
    "cave_tree_2",
    "finish_line",
    "sound_manager",
    "wallet",
    "map_master",
    "end_scene_trgr",
    "game_snd_master",
    "cave_silhouette_1",
    "touch_shield",
    "start_go_txt",
    "side_indicator",
    "acorns_bag",
    "gold_acorns_bag",
    "rainbow_juice",
    "mud_gnd_placeholder",
    "ground_placeholder",
    "block_hb",
    "block",
    "mud_gnd_back",
    "mud_gnd_front",
    "gnd_hb",
    "collectible_bubble"
    }
    ---------------------------------------------
    -- world5
    local world5Sprites = 
    {
    "down_button_hb",
    "rank_master",
    "bot_master",
    "game_master",
    "up_button_hb",
    "control_button",
    "debug_game_play_text",
    "debug_record_dump",
    "limbo_arrow_button",
    "progression_bar",
    "avatar_outline",
    "pwrup_dbg",
    "pwrup_cooldown_screen",
    "pwrup_symbol",
    "local_hero",
    "are_you_sure_dlg",
    "blue_x_button",
    "chicken_avatar_body",
    "pink_v_button",
    "chicken_avatar",
    "chicken_avatar_head",
    "pause_button",
    "pwrup_button",
    "rank_dbg",
    "pwrup_effect",
    "analytics_master",
    "start_button_iris",
    "hero",
    "camera",
    "chicken_skin",
    "gboost_2d_effect",
    "local_hero_indicator",
    "crest",
    "bands",
    "obstacles_master",
    "bg_factory",
    "fut_bg_tile_2",
    "fut_bg_tile_1",
    "fut_bg_tile_3",
    "ground",
    "ground_grass",
    "cloud_2",
    "cloud_4",
    "cloud_1",
    "cloud_6",
    "cloud_5",
    "hill_z1",
    "hill_z3",
    "hill_z2",
    "fut_city_silhouette_1",
    "fut_cliff",
    "fut_light_pole",
    "finish_line",
    "sound_manager",
    "wallet",
    "map_master",
    "end_scene_trgr",
    "game_snd_master",
    "touch_shield",
    "start_go_txt",
    "side_indicator",
    "acorns_bag",
    "gold_acorns_bag",
    "rainbow_juice",
    "mud_gnd_placeholder",
    "ground_placeholder",
    "block_hb",
    "block",
    "mud_gnd_back",
    "mud_gnd_front",
    "gnd_hb",
    "collectible_bubble"
    }

-----------------------------------------------------------------------------------
    local spritesToPreload
    if     current_world == 1 then 
        spritesToPreload = world1Sprites        
    elseif current_world == 2 then 
        spritesToPreload = world2Sprites
    elseif current_world == 3 then 
        spritesToPreload = world3Sprites
    elseif current_world == 4 then 
        spritesToPreload = world4Sprites
    elseif current_world == 5 then 
        spritesToPreload = world5Sprites
    end
    -------------------------------------------------------------
    if spritesToPreload ~= nil then                                                               
        resourceManager.addSpritesToNextPreload(spritesToPreload)
    end
    -------------------------------------------------------------
    if rank_for_scenes == 0 then 
       resourceManager.addSpritesToNextPreload(tutorialSprites)             
    end



    -- find props and pets in use
    local hatsInUse     = {player_1_head, player_2_head, player_3_head, player_4_head}
    local bodiesInUse   = {player_1_body, player_2_body, player_3_body, player_4_body}
    local petsInUse     = {player_1_pet , player_2_pet , player_3_pet , player_4_pet }
   
  
    local hatSprites = {}
    hatSprites[PROP_KING_CROWN     ]  = "limbo_king_crown"       
    hatSprites[PROP_PIRATE_HAT     ]  = "limbo_pirate_hat"     
    hatSprites[PROP_CAVEMAN_HAT    ]  = "limbo_caveman_helmet" 
    hatSprites[PROP_WIZARD_HAT     ]  = "limbo_wizard_hat"     
    hatSprites[PROP_DEMON_HELMET   ]  = "limbo_demon_helmet"   
    hatSprites[PROP_SOLDIER_HELMET ]  = "limbo_soldier_helmet" 
    hatSprites[PROP_ROBOT_HELMET   ]  = "limbo_robot_helmet"                           
    
    local bodiesSprites = {}
    bodiesSprites[PROP_KING_CAPE    ] = "limbo_general_cape" 
    bodiesSprites[PROP_PIRATE_BELT  ] = "limbo_pirate_belt"  
    bodiesSprites[PROP_CAVEMAN_CAPE ] = "limbo_general_cape" 
    bodiesSprites[PROP_WIZARD_CAPE  ] = "limbo_general_cape" 
    bodiesSprites[PROP_DEMON_CAPE   ] = "limbo_general_cape" 
    bodiesSprites[PROP_SOLDIER_BELT ] = "limbo_soldier_belt" 
    bodiesSprites[PROP_ROBOT_BELT   ] = "limbo_robot_belt"   

    local petsSprites = {}
    petsSprites[PET_ROBOT         ] = "robot_pet"       --"robot_beam"
    petsSprites[PET_CHICK         ] = {"chick_pet"}
    petsSprites[PET_GOLD_DRAGON   ] = "dragon_gold_pet"
    petsSprites[PET_DEMON         ] = "demon_pet"       --"demon_particle"
    petsSprites[PET_PURPLE_DRAGON ] = "dragon_purple_pet"
    petsSprites[PET_ASTROCAT      ] = "astrocat_pet"
    petsSprites[PET_ALIEN         ] = "alien_pet"
    petsSprites[PET_ANGEL         ] = "angel_pet"       --"angel_particle"
    petsSprites[PET_DEATH_ANGEL   ] = "death_angel_pet"
   
    local propsToPreload = {}

    function AddSpriteToList(propsInUse, spritesList, preloadList)
        for _, v in ipairs(propsInUse) do
            table.insert(preloadList, spritesList[v])
        end
    end
    
    AddSpriteToList(hatsInUse, hatSprites, propsToPreload)
    AddSpriteToList(bodiesInUse, bodiesSprites, propsToPreload)
    AddSpriteToList(petsInUse, petsSprites, propsToPreload)

     resourceManager.addSpritesToNextPreload(propsToPreload)

end
