local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'game_master')
local analytics = game.analyticsHelper
sprite:clearcache()


return function()
    local gm = require 'engine.manager'
    local resourceManagerLoaded, resourceManager = pcall(require, 'engine.resourceManager')
    
    if resourceManagerLoaded then

      -----------------------------------------------------------------------------------
      local firstSessionSprites = {
      "limbo_master",
      "pets_storage_master",
      "sound_manager",
      "touch_shield",
      "calculator",
      "fb_score_parser",
      "wallet",
      "analytics_master",
      "rank_master",
      "map_master",
      "map_bg_part",
      "world_1_2",
      "world_2_1",
      "world_3_1",
      "world_4_1",
      "world_5_1",
      "limbo_bg_strip_1_bottom",
      "limbo_bg_strip_2",
      "limbo_bg_strip_3",
      "limbo_bg_strip_4",
      "limbo_bg_strip_5",
      "limbo_bg_strip_6",
      "limbo_bg_strip_7",
      "limbo_bg_strip_8",
      "limbo_bg_strip_9",
      "limbo_bg_strip_10",
      "mask_2_455x344_machine",
      "limbo_bush_3",
      "limbo_bush_3_reflection",
      "black_circle_machine",
      "white_circle_machine",
      "mask_2_14x315_house",
      "pet_house",
      "pet_house_skin_level_2",
      "upgrade_generic_button",
      "limbo_purple_dragon_pet",
      "limbo_egg",
      "pet_house_reflection",
      "black_circle_house",
      "white_circle_house",
      "mask_4_19x200",
      "limbo_palm_1",
      "limbo_palm_1_reflection",
      "black_circle_4",
      "white_circle_4",
      "mask_3_149x211",
      "dino",
      "dino_reflection",
      "black_circle_3",
      "white_circle_3",
      "limbo_hill_1",
      "mask_wallpaper_strip_0x181",
      "limbo_wallpaper_1",
      "limbo_wallpaper_reflection_1",
      "black_wallpaper_stripe",
      "mask_5_452x285",
      "limbo_rocks_1",
      "limbo_rocks_1_reflection",
      "black_circle_5",
      "white_circle_5",
      "bottom_buttons_fragment",
      "limbo_settings_button",
      "limbo_play_button",
      "social_master",
      "mission_master",
      "preplay_master",
      "pet_energy_master",
      "construction_big_bar_icon",
      "black_bar",
      "red_bar",
      "limbo_entrance_glow",
      "limbo_entrance_glow_circle",
      "limbo_chicken_entrance",
      "play_stroke_effect",
      "limbo_chicken_NEW",
      "limbo_chicken_NEW_crest",
      "limbo_chicken_reflection"
      }
      ---------------------------------
      local secondSessionSprites = {
      "limbo_master",
      "pets_storage_master",
      "sound_manager",
      "touch_shield",
      "calculator",
      "fb_score_parser",
      "wallet",
      "analytics_master",
      "rank_master",
      "map_master",
      "map_bg_part",
      "world_1_2",
      "world_2_1",
      "world_3_1",
      "world_4_1",
      "world_5_1",
      "limbo_bg_strip_1_bottom",
      "limbo_bg_strip_2",
      "limbo_bg_strip_3",
      "limbo_bg_strip_4",
      "limbo_bg_strip_5",
      "limbo_bg_strip_6",
      "limbo_bg_strip_7",
      "limbo_bg_strip_8",
      "limbo_bg_strip_9",
      "limbo_bg_strip_10",
      "mask_2_455x344_machine",
      "machine_store",
      "machine_blue_glass",
      "machine_store_reflection",
      "silo",
      "upgrade_generic_button",
      "silo_fill_up",
      "silo_fiil_top",
      "silo_tube",
      "silo_reflection",
      "black_circle_machine",
      "white_circle_machine",
      "mask_2_14x315_house",
      "pet_house",
      "pet_house_skin_level_2",
      "pet_house_reflection",
      "black_circle_house",
      "white_circle_house",
      "mask_4_19x200",
      "limbo_palm_1",
      "limbo_palm_1_reflection",
      "black_circle_4",
      "white_circle_4",
      "mask_3_149x211",
      "dino",
      "dino_reflection",
      "black_circle_3",
      "white_circle_3",
      "limbo_hill_1",
      "mask_7_622x288",
      "black_circle_7",
      "white_circle_7",
      "mask_wallpaper_strip_0x181",
      "limbo_wallpaper_1",
      "limbo_wallpaper_reflection_1",
      "black_wallpaper_stripe",
      "mask_5_452x285",
      "limbo_rocks_1",
      "limbo_rocks_1_reflection",
      "black_circle_5",
      "white_circle_5",
      "huds_fragment",
      "rainbow_display",
      "plus_generic_button",
      "stardust_display",
      "login_place_holder",
      "map_button",
      "inbox_button",
      "inbox_cnt_dsp",
      "xp_bar",
      "xp_bar_box",
      "xp_bar_xp_fill_up_first_part",
      "xp_bar_xp_fill_up",
      "xp_bar_progress_fill_up",
      "xp_bar_progress_fill_up_first_part",
      "bottom_buttons_fragment",
      "limbo_settings_button",
      "limbo_play_button",
      "social_master",
      "mission_master",
      "preplay_master",
      "text_bubble_big_mirrored",
      "tutorial_big_pink_arrow",
      "limbo_entrance_glow",
      "limbo_entrance_glow_circle",
      "limbo_chicken_entrance",
      "play_stroke_effect",
      "limbo_chicken_NEW",
      "limbo_chicken_NEW_crest",
      "limbo_chicken_reflection"
      }
      -------------------------------------------
      local world1Sprites = {
      "store_bg",
      "limbo_master",
      "pets_storage_master",
      "sound_manager",
      "touch_shield",
      "calculator",
      "fb_score_parser",
      "wallet",
      "analytics_master",
      "rank_master",
      "map_master",
      "map_bg_part",
      "world_1_2",
      "world_2_1",
      "world_3_1",
      "world_4_1",
      "world_5_1",
      "limbo_bg_strip_1_bottom",
      "limbo_bg_strip_2",
      "limbo_bg_strip_3",
      "limbo_bg_strip_4",
      "limbo_bg_strip_5",
      "limbo_bg_strip_6",
      "limbo_bg_strip_7",
      "limbo_bg_strip_8",
      "limbo_bg_strip_9",
      "limbo_bg_strip_10",
      "mask_2_455x344_machine",
      "machine_store",
      "machine_blue_glass",
      "machine_store_reflection",
      "silo",
      "upgrade_generic_button",
      "silo_fill_up",
      "silo_fiil_top",
      "silo_tube",
      "silo_reflection",
      "black_circle_machine",
      "white_circle_machine",
      "mask_2_14x315_house",
      "pet_house",
      "pet_house_skin_level_2",
      "pet_house_reflection",
      "black_circle_house",
      "white_circle_house",
      "mask_4_19x200",
      "limbo_palm_1",
      "limbo_palm_1_reflection",
      "black_circle_4",
      "white_circle_4",
      "mask_3_149x211",
      "dino",
      "dino_reflection",
      "black_circle_3",
      "white_circle_3",
      "limbo_hill_1",
      "mask_7_622x288",
      "black_circle_7",
      "white_circle_7",
      "mask_wallpaper_strip_0x181",
      "limbo_wallpaper_1",
      "limbo_wallpaper_reflection_1",
      "black_wallpaper_stripe",
      "mask_5_452x285",
      "limbo_rocks_1",
      "limbo_rocks_1_reflection",
      "black_circle_5",
      "white_circle_5",
      "huds_fragment",
      "rainbow_display",
      "plus_generic_button",
      "stardust_display",
      "login_place_holder",
      "map_button",
      "inbox_button",
      "inbox_cnt_dsp",
      "xp_bar",
      "xp_bar_box",
      "xp_bar_xp_fill_up_first_part",
      "xp_bar_xp_fill_up",
      "xp_bar_progress_fill_up",
      "xp_bar_progress_fill_up_first_part",
      "bottom_buttons_fragment",
      "limbo_settings_button",
      "limbo_play_button",
      "social_master",
      "mission_master",
      "preplay_master",
      "limbo_entrance_glow",
      "limbo_entrance_glow_circle",
      "limbo_chicken_entrance",
      "play_stroke_effect",
      "limbo_chicken_NEW",
      "limbo_chicken_NEW_crest",
      "limbo_chicken_reflection"
      }
      --------------------------------------------
      local world2Sprites = {
      "store_bg",
      "limbo_master",
      "pets_storage_master",
      "sound_manager",
      "touch_shield",
      "calculator",
      "fb_score_parser",
      "wallet",
      "analytics_master",
      "rank_master",
      "map_master",
      "map_bg_part",
      "world_1_2",
      "world_2_1",
      "world_3_1",
      "world_4_1",
      "world_5_1",
      "limbo_bg_strip_1_bottom",
      "limbo_bg_strip_2",
      "limbo_bg_strip_3",
      "limbo_bg_strip_4",
      "limbo_bg_strip_5",
      "limbo_bg_strip_6",
      "limbo_bg_strip_7",
      "limbo_bg_strip_8",
      "limbo_bg_strip_9",
      "limbo_bg_strip_10",
      "mask_9",
      "purple_crystal_MAGIC_1",
      "purple_crystal_MAGIC_1_reflection",
      "black_circle_9",
      "white_circle_9",
      "mask_8",
      "purple_crystal_MAGIC_2",
      "purple_crystal_MAGIC_2_reflection",
      "black_circle_8",
      "white_circle_8",
      "mask_2_455x344_machine",
      "machine_store",
      "machine_blue_glass",
      "machine_store_reflection",
      "silo",
      "upgrade_generic_button",
      "silo_fill_up",
      "silo_fiil_top",
      "silo_tube",
      "silo_reflection",
      "black_circle_machine",
      "white_circle_machine",
      "mask_2_14x315_house",
      "pet_house",
      "pet_house_skin_level_2",
      "pet_house_reflection",
      "black_circle_house",
      "white_circle_house",
      "mask_4_19x200",
      "limbo_tree_2_MAGIC",
      "limbo_tree_2_MAGIC_reflection",
      "black_circle_4",
      "white_circle_4",
      "mask_6_683x197",
      "limbo_bush_3",
      "limbo_bush_3_reflection",
      "black_circle_6",
      "white_circle_6",
      "mask_3_149x211",
      "magic_hat",
      "magic_hat_reflection",
      "black_circle_3",
      "white_circle_3",
      "mask_7_622x288",
      "limbo_tree_1_MAGIC",
      "limbo_tree_1_MAGIC_reflection",
      "black_circle_7",
      "white_circle_7",
      "mask_wallpaper_strip_0x181",
      "limbo_wallpaper_2",
      "limbo_wallpaper_reflection_2",
      "black_wallpaper_stripe",
      "mask_5_452x285",
      "limbo_rocks_1",
      "limbo_rocks_1_reflection",
      "black_circle_5",
      "white_circle_5",
      "huds_fragment",
      "rainbow_display",
      "plus_generic_button",
      "stardust_display",
      "login_place_holder",
      "map_button",
      "inbox_button",
      "inbox_cnt_dsp",
      "xp_bar",
      "xp_bar_box",
      "xp_bar_xp_fill_up_first_part",
      "xp_bar_xp_fill_up",
      "xp_bar_progress_fill_up",
      "xp_bar_progress_fill_up_first_part",
      "bottom_buttons_fragment",
      "limbo_settings_button",
      "limbo_play_button",
      "social_master",
      "mission_master",
      "preplay_master",
      "limbo_entrance_glow",
      "limbo_entrance_glow_circle",
      "limbo_chicken_entrance",
      "play_stroke_effect",
      "limbo_chicken_NEW",
      "limbo_chicken_NEW_crest",
      "limbo_chicken_reflection"
      }
      --------------------------------------------------
      local world3Sprites = {
      "store_bg",
      "limbo_master",
      "pets_storage_master",
      "sound_manager",
      "touch_shield",
      "calculator",
      "fb_score_parser",
      "wallet",
      "analytics_master",
      "rank_master",
      "map_master",
      "map_bg_part",
      "world_1_2",
      "world_2_1",
      "world_3_1",
      "world_4_1",
      "world_5_1",
      "limbo_bg_strip_1_bottom",
      "limbo_bg_strip_2",
      "limbo_bg_strip_3",
      "limbo_bg_strip_4",
      "limbo_bg_strip_5",
      "limbo_bg_strip_6",
      "limbo_bg_strip_7",
      "limbo_bg_strip_8",
      "limbo_bg_strip_9",
      "limbo_bg_strip_10",
      "mask_8",
      "limbo_small_stone_DESTROYED",
      "limbo_small_stone_DESTROYED_reflection",
      "black_circle_8",
      "white_circle_8",
      "mask_2_455x344_machine",
      "machine_store",
      "machine_blue_glass",
      "machine_store_reflection",
      "silo",
      "upgrade_generic_button",
      "silo_fill_up",
      "silo_fiil_top",
      "silo_tube",
      "silo_reflection",
      "black_circle_machine",
      "white_circle_machine",
      "mask_2_14x315_house",
      "pet_house",
      "pet_house_skin_level_2",
      "pet_house_reflection",
      "black_circle_house",
      "white_circle_house",
      "mask_4_19x200",
      "limbo_tree_2_DESTROYED",
      "limbo_tree_2_DESTROYED_reflection",
      "black_circle_4",
      "white_circle_4",
      "mask_6_683x197",
      "limbo_bush_3",
      "limbo_bush_3_reflection",
      "black_circle_6",
      "white_circle_6",
      "mask_3_149x211",
      "stone_DESTROYED",
      "stone_DESTROYED_reflection",
      "black_circle_3",
      "white_circle_3",
      "mask_wallpaper_strip_0x181",
      "limbo_wallpaper_3",
      "limbo_wallpaper_reflection_3",
      "black_wallpaper_stripe",
      "mask_5_452x285",
      "limbo_rocks_1",
      "limbo_rocks_1_reflection",
      "black_circle_5",
      "white_circle_5",
      "huds_fragment",
      "rainbow_display",
      "plus_generic_button",
      "stardust_display",
      "login_place_holder",
      "map_button",
      "inbox_button",
      "inbox_cnt_dsp",
      "xp_bar",
      "xp_bar_box",
      "xp_bar_xp_fill_up_first_part",
      "xp_bar_xp_fill_up",
      "xp_bar_progress_fill_up",
      "xp_bar_progress_fill_up_first_part",
      "bottom_buttons_fragment",
      "limbo_settings_button",
      "limbo_play_button",
      "social_master",
      "mission_master",
      "preplay_master",
      "limbo_entrance_glow",
      "limbo_entrance_glow_circle",
      "limbo_chicken_entrance",
      "play_stroke_effect",
      "limbo_chicken_NEW",
      "limbo_chicken_NEW_crest",
      "limbo_chicken_reflection"
      }
      ------------------------------------
      local world4Sprites = {
      "store_bg",
      "limbo_master",
      "pets_storage_master",
      "sound_manager",
      "touch_shield",
      "calculator",
      "fb_score_parser",
      "wallet",
      "analytics_master",
      "rank_master",
      "map_master",
      "map_bg_part",
      "world_1_2",
      "world_2_1",
      "world_3_1",
      "world_4_1",
      "world_5_1",
      "limbo_bg_strip_1_bottom",
      "limbo_bg_strip_2",
      "limbo_bg_strip_3",
      "limbo_bg_strip_4",
      "limbo_bg_strip_5",
      "limbo_bg_strip_6",
      "limbo_bg_strip_7",
      "limbo_bg_strip_8",
      "limbo_bg_strip_9",
      "limbo_bg_strip_10",
      "mask_8",
      "limbo_tennies_balls_DOG",
      "limbo_tennies_balls_DOG_reflection",
      "black_circle_8",
      "white_circle_8",
      "mask_9",
      "limbo_footsteps_DOG",
      "black_circle_9",
      "white_circle_9",
      "mask_2_455x344_machine",
      "machine_store",
      "machine_blue_glass",
      "machine_store_reflection",
      "silo",
      "upgrade_generic_button",
      "silo_fill_up",
      "silo_fiil_top",
      "silo_tube",
      "silo_reflection",
      "black_circle_machine",
      "white_circle_machine",
      "mask_2_14x315_house",
      "pet_house",
      "pet_house_skin_level_2",
      "pet_house_reflection",
      "black_circle_house",
      "white_circle_house",
      "mask_4_19x200",
      "limbo_street_light_DOG",
      "limbo_street_light_DOG_reflection",
      "black_circle_4",
      "white_circle_4",
      "mask_3_149x211",
      "water_pipes_DOG",
      "water_pipes_DOG_reflection",
      "black_circle_3",
      "white_circle_3",
      "mask_7_622x288",
      "limbo_tree_1_DOG",
      "limbo_tree_1_DOG_reflection",
      "black_circle_7",
      "white_circle_7",
      "mask_wallpaper_strip_0x181",
      "limbo_wallpaper_4",
      "limbo_wallpaper_reflection_4",
      "black_wallpaper_stripe",
      "mask_5_452x285",
      "limbo_rocks_1",
      "limbo_rocks_1_reflection",
      "black_circle_5",
      "white_circle_5",
      "huds_fragment",
      "rainbow_display",
      "plus_generic_button",
      "stardust_display",
      "login_place_holder",
      "map_button",
      "inbox_button",
      "inbox_cnt_dsp",
      "xp_bar",
      "xp_bar_box",
      "xp_bar_xp_fill_up_first_part",
      "xp_bar_xp_fill_up",
      "xp_bar_progress_fill_up",
      "xp_bar_progress_fill_up_first_part",
      "bottom_buttons_fragment",
      "limbo_settings_button",
      "limbo_play_button",
      "social_master",
      "mission_master",
      "preplay_master",
      "limbo_entrance_glow",
      "limbo_entrance_glow_circle",
      "limbo_chicken_entrance",
      "play_stroke_effect",
      "limbo_chicken_NEW",
      "limbo_chicken_NEW_crest",
      "limbo_chicken_reflection"
      }
      --------------------------------------------------------
      local world5Sprites = {
      "store_bg",
      "limbo_master",
      "pets_storage_master",
      "sound_manager",
      "touch_shield",
      "calculator",
      "fb_score_parser",
      "wallet",
      "analytics_master",
      "rank_master",
      "map_master",
      "map_bg_part",
      "world_1_2",
      "world_2_1",
      "world_3_1",
      "world_4_1",
      "world_5_1",
      "limbo_bg_strip_1_bottom",
      "limbo_bg_strip_2",
      "limbo_bg_strip_3",
      "limbo_bg_strip_4",
      "limbo_bg_strip_5",
      "limbo_bg_strip_6",
      "limbo_bg_strip_7",
      "limbo_bg_strip_8",
      "limbo_bg_strip_9",
      "limbo_bg_strip_10",
      "mask_8",
      "limbo_lambs_FUTURE",
      "limbo_lambs_FUTURE_reflection",
      "black_circle_8",
      "white_circle_8",
      "mask_2_455x344_machine",
      "machine_store",
      "machine_blue_glass",
      "machine_store_reflection",
      "silo",
      "upgrade_generic_button",
      "silo_fill_up",
      "silo_fiil_top",
      "silo_tube",
      "silo_reflection",
      "black_circle_machine",
      "white_circle_machine",
      "mask_2_14x315_house",
      "pet_house",
      "pet_house_skin_level_2",
      "pet_house_reflection",
      "black_circle_house",
      "white_circle_house",
      "mask_4_19x200",
      "chicken_incubator_FUTURE",
      "chicken_incubator_FUTURE_reflection",
      "black_circle_4",
      "white_circle_4",
      "mask_7_622x288",
      "limbo_tree_1_FUTURE",
      "limbo_tree_1_FUTURE_reflection",
      "black_circle_7",
      "white_circle_7",
      "mask_wallpaper_strip_0x181",
      "limbo_wallpaper_5",
      "limbo_wallpaper_reflection_5",
      "black_wallpaper_stripe",
      "mask_5_452x285",
      "limbo_rocks_1",
      "limbo_rocks_1_reflection",
      "black_circle_5",
      "white_circle_5",
      "huds_fragment",
      "rainbow_display",
      "plus_generic_button",
      "stardust_display",
      "login_place_holder",
      "map_button",
      "inbox_button",
      "inbox_cnt_dsp",
      "xp_bar",
      "xp_bar_box",
      "xp_bar_xp_fill_up_first_part",
      "xp_bar_xp_fill_up",
      "xp_bar_progress_fill_up",
      "xp_bar_progress_fill_up_first_part",
      "bottom_buttons_fragment",
      "limbo_settings_button",
      "limbo_play_button",
      "social_master",
      "mission_master",
      "preplay_master",
      "limbo_entrance_glow",
      "limbo_entrance_glow_circle",
      "limbo_chicken_entrance",
      "play_stroke_effect",
      "limbo_chicken_NEW",
      "limbo_chicken_NEW_crest",
      "limbo_chicken_reflection"
      }

      local spritesToPreload = {}

      if current_world <= 1 then 
            if total_sessions_counter < 2 then 
                  spritesToPreload = firstSessionSprites
            elseif total_sessions_counter == 2 then 
                  spritesToPreload = secondSessionSprites
            else
                  spritesToPreload = world1Sprites      
            end
      elseif current_world == 2 then 
            spritesToPreload = world2Sprites
      elseif current_world == 3 then 
            spritesToPreload = world3Sprites
      elseif current_world == 4 then 
            spritesToPreload = world4Sprites
      elseif current_world == 5 then 
            spritesToPreload = world5Sprites
      end
      -----------------------------------------------------------------------------------      
      if spritesToPreload ~= nil then                                 
            resourceManager.addSpritesToNextPreload(spritesToPreload)
      end

        -- load  prop_on_head
             
        if prop_on_head ~= 0 then         
            local hat   
              if prop_on_head == PROP_KING_CROWN      then hat = "limbo_king_crown"       end
              if prop_on_head == PROP_PIRATE_HAT      then hat = "limbo_pirate_hat"       end
              if prop_on_head == PROP_CAVEMAN_HAT     then hat = "limbo_caveman_helmet"   end
              if prop_on_head == PROP_WIZARD_HAT      then hat = "limbo_wizard_hat"       end
              if prop_on_head == PROP_DEMON_HELMET    then hat = "limbo_demon_helmet"     end
              if prop_on_head == PROP_SOLDIER_HELMET  then hat = "limbo_soldier_helmet"   end
              if prop_on_head == PROP_ROBOT_HELMET    then hat = "limbo_robot_helmet"     end

              if hat ~= nil then resourceManager.addSpritesToNextPreload({hat}) end
        end
        
        -- load prop_on_torso
        
        if prop_on_torso ~= 0 then         

            local torso
              if prop_on_torso == PROP_KING_CAPE      then torso = "limbo_general_cape"   end
              if prop_on_torso == PROP_PIRATE_BELT    then torso = "limbo_pirate_belt"    end
              if prop_on_torso == PROP_CAVEMAN_CAPE   then torso = "limbo_general_cape"   end
              if prop_on_torso == PROP_WIZARD_CAPE    then torso = "limbo_general_cape"   end
              if prop_on_torso == PROP_DEMON_CAPE     then torso = "limbo_general_cape"   end
              if prop_on_torso == PROP_SOLDIER_BELT   then torso = "limbo_soldier_belt"   end
              if prop_on_torso == PROP_ROBOT_BELT     then torso = "limbo_robot_belt"     end

              if torso ~= nil then resourceManager.addSpritesToNextPreload({torso}) end
        end

    end
end
