local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'preplay_master')
local analytics = game.analyticsHelper
sprite:clearcache()


-------------------------------------------------
-- friend data class definition
-------------------------------------------------
local CFriendData = {}
CFriendData.__index = CFriendData

--pseudo c'tor - redirect to the new() method
setmetatable(CFriendData, {
	__call = function (cls, ...)
		return cls.new(...)
	end,
})
--actual c'tor
function CFriendData.new(id_,index_,name_)
	local this = setmetatable({}, CFriendData)
	this.fb_id 		= tonumber(id_)
	this.fb_index 	= tonumber(index_)
	this.name 		= name_
	return this
end

function  CFriendData.PrintMe(this)
	print("fdata: id=" .. this.fb_id .. ", index=" .. this.fb_index .. ", name=" .. this.name)
end
--------------------------------------------------
-- Preplay master singletone definition
--------------------------------------------------
PreplayMaster = {}
PreplayMaster.Friends = {}
---------------------------------------------------------
function PreplayMaster.PrintFriendsData()
	for i=1, #PreplayMaster.Friends do
		CFriendData.PrintMe(PreplayMaster.Friends[i])
	end
end
---------------------------------------------------------
function  PreplayMaster.SetFriendData(k, fb_id, fb_index, fb_name)
	if(k > 0 and k <= #PreplayMaster.Friends) then
		PreplayMaster.Friends[k] = CFriendData(fb_id, fb_index, fb_name)
	end
end
---------------------------------------------------------
function PreplayMaster.GetInvitedFriendsList()
	local fl = {}
	for i=1, #PreplayMaster.Friends do
		if(PreplayMaster.Friends[i].fb_id ~= -1) then
			table.insert(fl, PreplayMaster.Friends[i].fb_id)
		end
	end
	return fl
end
---------------------------------------------------------
-- init
---------------------------------------------------------
for i=1, 3 do
	PreplayMaster.Friends[i] = CFriendData(-1,-1,-1)
end
--------------------------------------------------------
-- debug------------------------------------------------
--------------------------------------------------------
--PreplayMaster.PrintFriendsData()

