local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'hero')
local type = game.gm.getLocalIndicator(0, "type")
local id = game.gm.getLocalIndicator(0, "id")
local bots_simulation_for_demo = game.gm.getLocalIndicator(0, "bots_simulation_for_demo")
local analytics = game.analyticsHelper
sprite:clearcache()


local function squareDistance(x1, y1, x2, y2)
    local dx = x2 - x1
    local dy = y2 - y1
    return dx * dx + dy * dy
end

local function squareDistanceToMe(heroSprite)
    return squareDistance(
            heroSprite.XPos, heroSprite.YPos,
            self.XPos, self.YPos)
end

local otherHeroes = filter(spriteList(hero), function(heroSprite)
    return heroSprite.my_id ~= self.my_id
end)


local  chance = 101
-- in case of bot increase chance to get human as target
if (self.is_shadow == 1 ) then 
    chance = math.random(100)    
end

if (chance < bots_chance_to_real_target) then 
    
    otherHeroes = filter(otherHeroes, function(heroSprite)
        return heroSprite.is_shadow == 0
    end)

end

-- find a nearest player from all kinds 
table.sort(otherHeroes, function(a, b)
    return squareDistanceToMe(a) < squareDistanceToMe(b)
end)

if otherHeroes[1] ~= nil then
    tmp = otherHeroes[1].my_id
else
    print("PWRUP:: THIS SHOULD NEVER HAPPEN, no humans/ no bots found")
    tmp = 0
end

print("set_closest_target:: tmp = " .. tmp .. "[shadow=" .. self.is_shadow .. ", my_id=" .. self.my_id)









