local game = require 'game'
local sprite = game.sprite
local social = game.socialHelper
local self = sprite:create(game.gm.getLocalIndicator(0, "self"),'store_bg')
local analytics = game.analyticsHelper
sprite:clearcache()


Store = {}

Store.prop = {}
Store.prop.KING = 	{hat = 8 , misc = 9 }
Store.prop.PIRATE = 	{hat = 11, misc = 10}
Store.prop.CAVEMAN = 	{hat = 16, misc = 17}
Store.prop.WIZARD = 	{hat = 14, misc = 15}
Store.prop.DEMON = 		{hat = 4 , misc = 6 }
Store.prop.SOLDIER = 	{hat = 13, misc = 12}
Store.prop.ROBOT = 		{hat = 18, misc = 3 }
Store.prop.EGG1 = 25
Store.prop.EGG2 = 26
Store.prop.EGG3 = 27
----------------------------------------------------
Store.hats = {}
local sp = Store.prop
Store.hats[1] = sp.KING.hat
Store.hats[2] = sp.PIRATE.hat
Store.hats[3] = sp.CAVEMAN.hat
Store.hats[4] = sp.WIZARD.hat
Store.hats[5] = sp.DEMON.hat
Store.hats[6] = sp.SOLDIER.hat
Store.hats[7] = sp.ROBOT.hat
----------------------------------------------------
Store.miscs = {}
Store.miscs[1] = sp.KING.misc
Store.miscs[2] = sp.PIRATE.misc
Store.miscs[3] = sp.CAVEMAN.misc
Store.miscs[4] = sp.WIZARD.misc
Store.miscs[5] = sp.DEMON.misc
Store.miscs[6] = sp.SOLDIER.misc
Store.miscs[7] = sp.ROBOT.misc
----------------------------------------------------
Store.eggs = {}
Store.eggs[1] = sp.EGG1
Store.eggs[2] = sp.EGG2
Store.eggs[3] = sp.EGG3
----------------------------------------------------

Store.curr_item_index = 1
Store.curr_category = 1
Store.curr_items = Store.hats

----------------------------------------------------
Store.items_data = {}
--															{name, price, required level, have_it, crafting, accelleration_price, place in list, category, set}
 Store.items_data[Store.prop.KING.hat] 		= StoreItem.new("Crown"			,     0,  0, has_prop_king_hat,		0, 		0, 1,	1, PROP_SET_KING)
 if(IS_YAN == 0) then
 	Store.items_data[Store.prop.PIRATE.hat] = StoreItem.new("White Skull"	,   100,  5, has_prop_pirate_hat,	0.25, 	3, 	2,	1, PROP_SET_PIRATE)
 else
 	Store.items_data[Store.prop.PIRATE.hat] = StoreItem.new("White Skull"	,   100,  5, has_prop_pirate_hat,	1/60, 	3,  2,	1, PROP_SET_PIRATE)
 end
 Store.items_data[Store.prop.CAVEMAN.hat] 	= StoreItem.new("Tribal Mask"	,   100,  0, has_prop_caveman_hat,	1,		5, 3,	1, PROP_SET_CAVEMAN)
 Store.items_data[Store.prop.WIZARD.hat] 	= StoreItem.new("Spark"			,	500, 11, has_prop_wizard_hat,	1,		10,4,	1, PROP_SET_WIZARD)
 Store.items_data[Store.prop.DEMON.hat] 	= StoreItem.new("Hot Flames"	,  1500, 16, has_prop_demon_hat,	3,		35,5,	1, PROP_SET_DEMON)
 Store.items_data[Store.prop.SOLDIER.hat] 	= StoreItem.new("Chameleon"	    ,  3000, 20, has_prop_soldier_hat, 	5,		60,6,	1, PROP_SET_SOLDIER)
 Store.items_data[Store.prop.ROBOT.hat] 	= StoreItem.new("Devastator"	,  7500, 26, has_prop_robot_hat, 	8,		100,7,	1, PROP_SET_ROBOT)

 Store.items_data[Store.prop.KING.misc] 	= StoreItem.new("Royalty"		,    0,  0, has_prop_king_misc, 	0,		0,1,	2, PROP_SET_KING)
 Store.items_data[Store.prop.PIRATE.misc] 	= StoreItem.new("Gold Buckle"	,  100,  7, has_prop_pirate_misc, 	0.5,	6,2,	2, PROP_SET_PIRATE)
 Store.items_data[Store.prop.CAVEMAN.misc] 	= StoreItem.new("Iron Cape"		,  100,  0, has_prop_caveman_misc, 	1,		5,3,	2, PROP_SET_CAVEMAN)
 Store.items_data[Store.prop.WIZARD.misc] 	= StoreItem.new("Winds of Nature",1000, 13, has_prop_wizard_misc, 	2,		25,4,	2, PROP_SET_WIZARD)
 Store.items_data[Store.prop.DEMON.misc] 	= StoreItem.new("Lava Cape"	    , 2000, 18, has_prop_demon_misc, 	4,		50,5,	2, PROP_SET_DEMON)
 Store.items_data[Store.prop.SOLDIER.misc] 	= StoreItem.new("Utility Belt"	, 4500, 23, has_prop_soldier_misc, 	6,		75,6,	2, PROP_SET_SOLDIER)
 Store.items_data[Store.prop.ROBOT.misc] 	= StoreItem.new("Power Jetpack"	,10000, 30, has_prop_robot_misc,	12,		150,7,	2, PROP_SET_ROBOT)

 Store.items_data[Store.prop.EGG1] 			= StoreItem.new("Normal Egg"	, 400 ,	 3, nil, 					6,	 	0,1,3)
 Store.items_data[Store.prop.EGG2] 			= StoreItem.new("Gold Egg"		, 2000,	10, nil, 					48, 	0,2,3)
 Store.items_data[Store.prop.EGG3] 			= StoreItem.new("Mystical Egg"	, 4500, 15, nil, 					168, 	0,3,3)

 --for key,value in pairs(Store.items_data) do   StoreItem.PrintMe(Store.items_data[key]) end
----------------------------------------------------------------------------------
 if item_in_crafting ~= 0 then 
 	Store.curr_item_index = Store.items_data[item_in_crafting].place_in_list
 	Store.curr_category = Store.items_data[item_in_crafting].category
 	
 	if Store.curr_category == 1 then 
 		Store.curr_items = Store.hats 
 	elseif Store.curr_category == 2 then
 		Store.curr_items = Store.miscs
 	end 	
 
 end
----------------------------------------------------------------------------------
function  Store.OnArrow(dir)
	if dir == 1 then
		if (Store.curr_item_index < #Store.curr_items) then Store.curr_item_index = Store.curr_item_index + 1 
		else Store.curr_item_index = 1 end
	else
		if (Store.curr_item_index > 1) then Store.curr_item_index = Store.curr_item_index - 1 
		else Store.curr_item_index = #Store.curr_items end
	end
	local hide_text
	if(Store.curr_items[Store.curr_item_index] == item_in_crafting) then  hide_text = true end
	Store.UpdateCurrentItem(hide_text)
	self.is_virgin = 0	
	local is_item_on_me = Store.IsItemOnMe(store_bg.my_curr_item.my_type)
	if(is_item_on_me == 1) then 
		Store.WearCurrentProp(0)		
	else
		Store.WearCurrentProp(1)
	end
end
----------------------------------------------------------------------------------
function Store.SetItem(item_type, on_crafting_end)
	if(item_type ~= 0)	then		
		Store.curr_item_index = Store.items_data[item_type].place_in_list
		Store.curr_category = Store.items_data[item_type].category

		if(Store.curr_category == 1) then 	
			Store.curr_items = Store.hats 
		elseif(Store.curr_category == 2) then 
			Store.curr_items = Store.miscs
		elseif(Store.curr_category == 3) then 
			Store.curr_items = Store.eggs
		end

		if( on_crafting_end ) then	Store.items_data[item_type].have_it = 1 end
		Store.UpdateCurrentItem(on_crafting_end)
	end
end
----------------------------------------------------------------------------------
function Store.UpdateTextAndPriceForCurrentItem(hide_status_line)	
	
	store_item_text.canvas.TextFrame.text = Store.items_data[Store.curr_items[Store.curr_item_index]].name		
	local crafting_time = Store.items_data[Store.curr_items[Store.curr_item_index]].crafting_time
	local crafting_calendar_time = Store.ConvertHoursToCalendarFormat(crafting_time)
					
	if (item_in_crafting == Store.curr_items[Store.curr_item_index]) then 
		-- CRAFTING
		store_bg.my_curr_item.store_item_cap.set_alpha({a=128})
		store_bg.my_rainbow_icon.set_alpha({a=0})		
		if (store_bg.my_energy_master.Length > 0) then store_bg.my_energy_master.make_visible({}) end		
		store_price_text.canvas.TextFrame.text = ""
		store_bg.my_curr_item.price = 0		
	elseif (current_level < Store.items_data[Store.curr_items[Store.curr_item_index]].level) then
		-- LEVEL ISSUE
		store_bg.my_curr_item.store_item_cap.set_alpha({a=64})
		store_bg.my_rainbow_icon.set_alpha({a=255})
		store_item_status_text.canvas.TextFrame.text = Store.CalendarTimeToString(crafting_calendar_time)	
		store_price_text.canvas.TextFrame.text = Store.items_data[Store.curr_items[Store.curr_item_index]].price
		store_bg.my_curr_item.price = 0
		if (store_bg.my_energy_master.Length > 0) then store_bg.my_energy_master.change_to_invisible({}) end
	elseif(	Store.items_data[Store.curr_items[Store.curr_item_index]].have_it ~= 0)then
		-- HAVE IT
		store_bg.my_curr_item.store_item_cap.set_alpha({a=255})
		store_bg.my_rainbow_icon.set_alpha({a=0})
		store_item_status_text.canvas.TextFrame.text = ""
		store_price_text.canvas.TextFrame.text = ""
		store_bg.my_curr_item.price = 0
		if (store_bg.my_energy_master.Length > 0) then store_bg.my_energy_master.change_to_invisible({}) end		
	else
		-- CAN BUY
		if(store_bg.my_curr_item.Length > 0) then 
			store_bg.my_curr_item.store_item_cap.set_alpha({a=255})			
		end
		if (crafting_time > 0 )	 then
			store_item_status_text.canvas.TextFrame.text = Store.CalendarTimeToString(crafting_calendar_time)	
		else
			store_item_status_text.canvas.TextFrame.text = ""
		end
		if (Store.items_data[Store.curr_items[Store.curr_item_index]].price > 0) then
			store_price_text.canvas.TextFrame.text = Store.items_data[Store.curr_items[Store.curr_item_index]].price		
			store_bg.my_rainbow_icon.set_alpha({a=255})
		else
			store_price_text.canvas.TextFrame.text = ""
			store_bg.my_rainbow_icon.set_alpha({a=0})
		end
		store_bg.my_curr_item.price = Store.items_data[Store.curr_items[Store.curr_item_index]].price	
		
		store_bg.craft_d = crafting_calendar_time.d
		store_bg.craft_h = crafting_calendar_time.h
		store_bg.craft_m = crafting_calendar_time.m
		if (store_bg.my_energy_master.Length > 0) then store_bg.my_energy_master.change_to_invisible({}) end		
	end		
	store_bg.my_curr_item.my_type = Store.curr_items[Store.curr_item_index]		
	store_bg.my_curr_item.acc_price = Store.items_data[Store.curr_items[Store.curr_item_index]].acc_price
	store_locked.set_level({lvl=Store.items_data[Store.curr_items[Store.curr_item_index]].level})
	if(store_bg.my_buy_button.Length > 0) then Store.UpdateButtons() end
	if(hide_status_line) then store_item_status_text.canvas.TextFrame.text = "" end
end
----------------------------------------------------------------------------------
function Store.UpdateCurrentItem(hide_status_line)
	
	print("----------------------- UPDATE CURRENT ITEM -----------------")
	print("Store.curr_item_index = " .. Store.curr_item_index)
	print("Store.curr_category = " .. Store.curr_category)
	if(Store.curr_items ~= nil) then 
		print("#items = " .. #Store.curr_items)
	else
		print("Store.curr_items ~= nil")
	end
	print("----------------------- /UPDATE CURRENT ITEM -----------------")

	store_bg.display_item({item_id = Store.curr_items[Store.curr_item_index], category = Store.curr_category})	
	Store.UpdateTextAndPriceForCurrentItem(hide_status_line)
	Store.UpdateSkillIcons()		
end
----------------------------------------------------------------------------------
function Store.OnCategoryButton(num, force_change)
	if (num ~= Store.curr_category or force_change == true) then
		store_bg.remove_purchase_indicator({})
		Store.curr_category = num
		Store.curr_item_index = 1
		
		if (num == 1) then 
			Store.curr_items = Store.hats			
			store_bg.my_chicken.set_misc_prop({type=prop_on_torso})
			if (prop_on_head == Store.curr_items[Store.curr_item_index]	) then Store.WearCurrentProp(0) 
			else Store.WearCurrentProp(1) end
			
		elseif (num == 2) then 
			Store.curr_items = Store.miscs			
			store_bg.my_chicken.set_head_prop({type=prop_on_head})
			if (prop_on_torso == Store.curr_items[Store.curr_item_index]	) then Store.WearCurrentProp(0) 
			else Store.WearCurrentProp(1) end
		else 
			Store.curr_items = Store.eggs 
			store_bg.my_chicken.set_head_prop({type=prop_on_head})
			store_bg.my_chicken.set_misc_prop({type=prop_on_torso})
		end
		Store.UpdateCurrentItem()
		Store.UpdateSkillGlobal()
		Store.UpdateHeroSkillDisplay()

	end
	self.is_virgin = 0
end
----------------------------------------------------------------------------------
--output format {d,h,m}
function  Store.ConvertHoursToCalendarFormat(hours)
	local time = hours
	local r = {d=0, h=0, m=0}
	-- minutes
	local ms = 	time%1	
	if( ms > 0) then		
		r.m = ms*60
		time = math.floor(time)
	end
	if(time >= 1) then 
		-- days
		r.d = math.floor(time/24)
		--hours
		r.h  = time - r.d*24
	end
	--print("r = " .. r.d .. ":" .. r.h .. ":" .. r.m)
	return r 
end
----------------------------------------------------------------------------------
function Store.CalendarTimeToString(time)
	local d_str = ""
	if time.d > 0 then d_str =tostring(time.d) .. "d " end
	local h_str = tostring(time.h)
	if (time.h < 10) then h_str = "0" .. h_str end
	local m_str = tostring(time.m)
	if (time.m < 10) then m_str = "0" .. m_str end
	local result =  d_str .. h_str .. ":" .. m_str .. ":00"	
	return result
end
----------------------------------------------------------------------------------
function Store.UpdateItemStateAfterCrafting(t)
	Store.items_data[t].have_it = 1
	
	if(store_bg.my_curr_item.my_type == t) then 
		Store.curr_category = Store.items_data[t].category
		Store.UpdateCurrentItem()
	end	
end
----------------------------------------------------------------------------------
function Store.WearCurrentProp(try_mode)		
	local item_to_wear_type = Store.curr_items[Store.curr_item_index]		
	if(store_bg.my_curr_item.Length > 0) then store_bg.my_curr_item.my_type = item_to_wear_type end
	
	if(Store.curr_category == 1) then				
		store_bg.my_chicken.set_head_prop({type=item_to_wear_type})
		if(try_mode==1) then 
			--store_bg.my_chicken.set_hat_prop_alpha({a=200}) 
			store_bg.my_chicken.set_prop_pumping({is_hat=1, on=1}) 
		else 
			limbo_master.my_chicken.set_head_prop({type=item_to_wear_type})
			prop_on_head = item_to_wear_type
			store_bg.my_chicken.set_prop_pumping({is_hat=1, on=0}) 
		end
	elseif(Store.curr_category == 2) then
		store_bg.my_chicken.set_misc_prop({type=item_to_wear_type})
		if(try_mode==1) then 
			--store_bg.my_chicken.set_misc_prop_alpha({a=200}) 
			store_bg.my_chicken.set_prop_pumping({is_hat=0, on=1}) 
		else 
			limbo_master.my_chicken.set_misc_prop({type=item_to_wear_type})
			prop_on_torso = item_to_wear_type
			store_bg.my_chicken.set_prop_pumping({is_hat=0, on=0}) 
		end
	else
		print("-------------->> ERROR:: CAN'T WEAR THE EGG!!!")
	end	
	
	Store.UpdateSkillIcons()
	if(store_bg.is_initialized == 1) then 
		Store.UpdateHeroSkillDisplay()
	end

	if( try_mode == 0) then Store.UpdateSkillGlobal() end
	
end
----------------------------------------------------------------------------------
function  Store.UpdateBuyButtonAfterCraftRush()
	local WEAR = 2
	if (item_in_crafting == Store.curr_items[Store.curr_item_index]) then 		
		store_bg.my_buy_button.set_mode({m=WEAR})			
	end
end
----------------------------------------------------------------------------------
function Store.UpdateButtons()		
	local BUY    = 1
	local WEAR 	 = 2
	local RUSH 	 = 3
	local LOCKED = 4
	local CLEAR  = 5

	if(store_bg.Length > 0) then 
		if(store_bg.my_buy_button.Length > 0) then 

			if (item_in_crafting == Store.curr_items[Store.curr_item_index]) then 		
				store_bg.my_buy_button.set_mode({m=RUSH})		
			elseif (current_level < Store.items_data[Store.curr_items[Store.curr_item_index]].level) then		
				store_bg.my_buy_button.set_mode({m=LOCKED}) 			
			elseif( (Store.curr_category == 1 and Store.curr_items[Store.curr_item_index] == prop_on_head) or  
					(Store.curr_category == 2 and Store.curr_items[Store.curr_item_index] == prop_on_torso)) then 		
				print("SET CLEAR!!!")
				store_bg.my_buy_button.set_mode({m=CLEAR})		
			elseif(	Store.items_data[Store.curr_items[Store.curr_item_index]].have_it ~= 0 or Store.items_data[Store.curr_items[Store.curr_item_index]].price == 0)then		
				store_bg.my_buy_button.set_mode({m=WEAR})		
			else		
				store_bg.my_buy_button.set_mode({m=BUY})
			end
		end
	end
end
----------------------------------------------------------------------------------
function  Store.GetTotalCraftingTimeInMinutes()
	_RESULT = Store.items_data[item_in_crafting].crafting_time*60
end
----------------------------------------------------------------------------------
function Store.UpdateSkillIcons()
	if(self.my_skill_icons.Length > 0) then
		if(Store.curr_category == 1) then 
			self.my_skill_icons[1].set_type({t=Store.curr_items[Store.curr_item_index]})
		else
			self.my_skill_icons[1].set_type({t=prop_on_head})
		end

		if(Store.curr_category == 2) then 
			self.my_skill_icons[2].set_type({t=Store.curr_items[Store.curr_item_index]})
		else
			self.my_skill_icons[2].set_type({t=prop_on_torso})
		end
	end
end
----------------------------------------------------------------------------------
function  Store.CreateItemOnOpening()
	local is_item_on_me = 0		
	if(item_in_crafting == 0) then 
		self.display_item({category = 1, item_id = Store.prop.KING.hat})
		is_item_on_me = Store.IsItemOnMe(Store.prop.KING.hat)
	else
		self.display_item({category = Store.items_data[item_in_crafting].category, item_id = item_in_crafting})		
		Store.curr_item_index = Store.items_data[item_in_crafting].place_in_list
		-- upd curr category
		Store.curr_category = Store.items_data[item_in_crafting].category
	end	
	if(is_item_on_me==1) then 
		Store.WearCurrentProp(0) 
	else 
		Store.WearCurrentProp(1) 
	end

end
---------------------------------------------------------------------------------
function  Store.IsItemOnMe(t)
	local result
	
	if(t==prop_on_head or t==prop_on_torso) then 
		result =  1 
	else 
		result =  0 
	end
	--print ("t = " .. t .. ", on head = " .. prop_on_head .. ", on torso = " .. prop_on_torso .. ", result = " .. result)
	return result
end
---------------------------------------------------------------------------------
function Store.UpdateHeroSkillDisplay()	
	
	local i1 = 0
	local i2 = 0
	local set_id = 0
	
	if(Store.curr_category == 1 and prop_on_torso ~= 0) then 
		i1 = Store.curr_items[Store.curr_item_index]
		i2 = prop_on_torso
	elseif(Store.curr_category == 2 and prop_on_head ~= 0) then 			
		i1 = prop_on_head
		i2 = Store.curr_items[Store.curr_item_index]
	elseif(Store.curr_category == 3 and prop_on_head ~= 0 and prop_on_torso ~= 0) then 			
		i1 = prop_on_head
		i2 = prop_on_torso
	end

	if(i1 ~= 0) then 

		if(Store.items_data[i1].skill == Store.items_data[i2].skill) then 
			set_id = Store.HatPropIndexToSetIndex(i1) or 0	
		end
	else
		prop_curr_set = 0
	end	
	if(set_id == 0) then 
		store_bg.skill_msg({on = 0, skill = 0})
	else
		store_bg.skill_msg({on = 1, skill = set_id})
	end
end
---------------------------------------------------------------------------------
function Store.UpdateSkillGlobal()	
	if(prop_on_head ~= 0 and prop_on_torso ~= 0) then 
		if(Store.items_data[prop_on_head].skill == Store.items_data[prop_on_torso].skill) then 
			prop_curr_set = Store.HatPropIndexToSetIndex(prop_on_head) or 0
		else
			prop_curr_set = 0
		end
		--YAN TODO: update particles for limbo hero
		print("----------- prop_curr_set = " .. prop_curr_set)
	end
end
---------------------------------------------------------------------------------

function Store.HatPropIndexToSetIndex(t)
	local result
	if(t == Store.prop.KING.hat) 		then result = PROP_SET_KING
	elseif(t == Store.prop.PIRATE.hat) 	then result = PROP_SET_PIRATE
	elseif(t == Store.prop.CAVEMAN.hat) then result = PROP_SET_CAVEMAN
	elseif(t == Store.prop.WIZARD.hat) 	then result = PROP_SET_WIZARD
	elseif(t == Store.prop.DEMON.hat) 	then result = PROP_SET_DEMON
	elseif(t == Store.prop.SOLDIER.hat) then result = PROP_SET_SOLDIER
	elseif(t == Store.prop.ROBOT.hat) 	then result = PROP_SET_ROBOT
	else
		print("STR:: ----> ERROR => Set not found for t = " .. (t or "nil"))
	end
	return result
end
-------------------------------------------------------------------------------
function Store.UnwareItem()
	if(Store.curr_category == 1) then 
		prop_on_head = 0 		
		prop_curr_set = 0
	elseif(Store.curr_category == 2) then 
		prop_on_torso = 0
		prop_curr_set = 0
	end	
	Store.UpdateCurrentItem()
	Store.WearCurrentProp(1) -- wear in try mode
end
